/*
 *  GuiLoader, a GuiXml loader library
 *  Copyright (c) 2006-2010 Maxim Udushlivy
 *
 *  Permission is hereby granted, free of charge, to any person
 *  obtaining a copy of this software and associated documentation
 *  files (the "Software"), to deal in the Software without
 *  restriction, including without limitation the rights to use, copy,
 *  modify, merge, publish, distribute, sublicense, and/or sell copies
 *  of the Software, and to permit persons to whom the Software is
 *  furnished to do so, subject to the following conditions:
 *
 *  The above copyright notice and this permission notice shall be
 *  included in all copies or substantial portions of the Software.
 *
 *  The software is provided "as is", without warranty of any kind,
 *  express or implied, including but not limited to the warranties of
 *  merchantability, fitness for a particular purpose and
 *  noninfringement. In no event shall the authors or copyright
 *  holders be liable for any claim, damages or other liability,
 *  whether in an action of contract, tort or otherwise, arising from,
 *  out of or in connection with the software or the use or other
 *  dealings in the software.
 */

#include "proxies.h"
#include "containers.h"

void RegisterProxies(GuiLoaderInit * init) {

	RegisterGType(ATK_TYPE_RELATION_TYPE);
	RegisterGType(GDK_TYPE_EVENT_MASK);
	RegisterGType(GDK_TYPE_EXTENSION_MODE);
	RegisterGType(GTK_TYPE_SHADOW_TYPE);
	RegisterGType(GTK_TYPE_POLICY_TYPE);
	RegisterGType(GTK_TYPE_CORNER_TYPE);
	RegisterGType(GTK_TYPE_POSITION_TYPE);
	RegisterGType(GTK_TYPE_BUTTON_BOX_STYLE);
	RegisterGType(GDK_TYPE_GRAVITY);
	RegisterGType(GTK_TYPE_WINDOW_TYPE);
	RegisterGType(GDK_TYPE_WINDOW_TYPE_HINT);
	RegisterGType(GTK_TYPE_WINDOW_POSITION);
	RegisterGType(GTK_TYPE_ORIENTATION);
	RegisterGType(GTK_TYPE_TOOLBAR_STYLE);
	RegisterGType(GTK_TYPE_RESPONSE_TYPE);
	RegisterGType(GTK_TYPE_FILE_CHOOSER_ACTION);
	RegisterGType(GTK_TYPE_PACK_DIRECTION);
	RegisterGType(PANGO_TYPE_ELLIPSIZE_MODE);
	RegisterGType(GTK_TYPE_JUSTIFICATION);
	RegisterGType(GTK_TYPE_RELIEF_STYLE);
	RegisterGType(GTK_TYPE_SPIN_BUTTON_UPDATE_POLICY);
	RegisterGType(GTK_TYPE_UPDATE_TYPE);
	RegisterGType(GTK_TYPE_PROGRESS_BAR_ORIENTATION);
	RegisterGType(GTK_TYPE_ICON_SIZE);
	RegisterGType(GTK_TYPE_SIZE_GROUP_MODE);
	RegisterGType(GTK_TYPE_WRAP_MODE);
	RegisterGType(GTK_TYPE_SELECTION_MODE);
	RegisterGType(GTK_TYPE_ARROW_TYPE);
	RegisterGType(GTK_TYPE_RECENT_SORT_TYPE);
	RegisterGType(PANGO_TYPE_WRAP_MODE);
	RegisterGType(GTK_TYPE_SENSITIVITY_TYPE);
	RegisterGType(GTK_TYPE_TREE_VIEW_GRID_LINES);
	RegisterGType(GTK_TYPE_MESSAGE_TYPE);
	RegisterGType(GTK_TYPE_ASSISTANT_PAGE_TYPE);

	AddProxy(init, CROW_TYPE_RELATION_ENTRY, CrowRelationEntryProxy, 0);
	AddProxy(init, CROW_TYPE_ROW_CHILD, CrowChildProxy, 0);
	AddProxy(init, GTK_TYPE_ALIGNMENT, GtkAlignmentProxy, 0);
	AddProxy(init, GTK_TYPE_FRAME, GtkFrameProxy, 0);
	AddProxy(init, GTK_TYPE_ASPECT_FRAME, GtkAspectFrameProxy, 0);
	AddProxy(init, GTK_TYPE_EXPANDER, GtkExpanderProxy, 0);
	AddProxy(init, GTK_TYPE_SCROLLED_WINDOW, GtkScrolledWindowProxy, 0);
	AddProxy(init, GTK_TYPE_HANDLE_BOX, GtkHandleBoxProxy, 0);
	AddProxy(init, GTK_TYPE_VIEWPORT, GtkViewportProxy, 0);
	AddProxy(init, CROW_TYPE_BOX_CHILD, CrowBoxChildProxy, 0);
	AddProxy(init, GTK_TYPE_HBOX, GtkBoxProxy, 0);
	AddProxy(init, GTK_TYPE_VBOX, GtkBoxProxy, 0);
	AddProxy(init, CROW_TYPE_BUTTON_BOX_CHILD, CrowButtonBoxChildProxy, 0);
	AddProxy(init, GTK_TYPE_HBUTTON_BOX, GtkButtonBoxProxy, 0);
	AddProxy(init, GTK_TYPE_VBUTTON_BOX, GtkButtonBoxProxy, 0);
	AddProxy(init, CROW_TYPE_PANED_CHILD, CrowPanedChildProxy, 0);
	AddProxy(init, GTK_TYPE_HPANED, GtkPanedProxy, 0);
	AddProxy(init, GTK_TYPE_VPANED, GtkPanedProxy, 0);
	AddProxy(init, CROW_TYPE_NOTEBOOK_CHILD, CrowNotebookChildProxy, 0);
	AddProxy(init, GTK_TYPE_NOTEBOOK, GtkNotebookProxy, 0);
	AddProxy(init, CROW_TYPE_TABLE_CHILD, CrowTableChildProxy, 0);
	AddProxy(init, GTK_TYPE_TABLE, GtkTableProxy, 0);
	AddProxy(init, CROW_TYPE_XY_CHILD, CrowXYChildProxy, 0);
	AddProxy(init, GTK_TYPE_ADJUSTMENT, GtkAdjustmentProxy, 0);
	AddProxy(init, GTK_TYPE_WINDOW, GtkWindowProxy, 0);
	AddProxy(init, CROW_TYPE_ASSISTANT_CHILD, CrowAssistantChildProxy, 0);
	AddProxy(init, GTK_TYPE_ASSISTANT, GtkAssistantProxy, 0);
	AddProxy(init, CROW_TYPE_DIALOG_BUTTON_ENTRY, CrowDialogButtonEntryProxy, 0);
	AddProxy(init, GTK_TYPE_DIALOG, GtkDialogProxy, 0);
	AddProxy(init, CROW_TYPE_INFO_BAR_BUTTON_ENTRY, CrowInfoBarButtonEntryProxy, 0);
	AddProxy(init, GTK_TYPE_INFO_BAR, GtkInfoBarProxy, 0);
	AddProxy(init, GTK_TYPE_COLOR_SELECTION_DIALOG, GtkColorSelectionDialogProxy, 0);
	AddProxy(init, GTK_TYPE_FILE_FILTER, GtkFileFilterProxy, 0);
	AddProxy(init, GTK_TYPE_FILE_CHOOSER_DIALOG, GtkFileChooserDialogProxy, 0);
	AddProxy(init, GTK_TYPE_FONT_SELECTION_DIALOG, GtkFontSelectionDialogProxy, 0);
	AddProxy(init, GTK_TYPE_MENU_BAR, GtkMenuBarProxy, 0);
	AddProxy(init, GTK_TYPE_TOOLBAR, GtkToolbarProxy, 0);
	AddProxy(init, GTK_TYPE_TOOL_PALETTE, GtkToolPaletteProxy, 0);
	AddProxy(init, GTK_TYPE_STATUSBAR, GtkStatusbarProxy, 0);
	AddProxy(init, GTK_TYPE_ACTION_GROUP, GtkActionGroupProxy, -2);
	AddProxy(init, GTK_TYPE_ACTION, GtkActionProxy, 0);
	AddProxy(init, GTK_TYPE_TOGGLE_ACTION, GtkToggleActionProxy, 0);
	AddProxy(init, GTK_TYPE_RADIO_ACTION, GtkRadioActionProxy, 0);
	AddProxy(init, GTK_TYPE_UI_MANAGER, GtkUIManagerProxy, -1);
	AddProxy(init, CROW_TYPE_UI_DEFINITION, CrowUIDefinitionProxy, -2);
	AddProxy(init, CROW_TYPE_RADIO_GROUP, CrowRadioGroupProxy, -3);
	AddProxy(init, GTK_TYPE_LABEL, GtkLabelProxy, 0);
	AddProxy(init, GTK_TYPE_BUTTON, GtkButtonProxy, 0);
	AddProxy(init, GTK_TYPE_TOGGLE_BUTTON, GtkToggleButtonProxy, 0);
	AddProxy(init, GTK_TYPE_CHECK_BUTTON, GtkCheckButtonProxy, 0);
	AddProxy(init, GTK_TYPE_RADIO_BUTTON, GtkRadioButtonProxy, 0);
	AddProxy(init, GTK_TYPE_SCALE_BUTTON, GtkScaleButtonProxy, 0);
	AddProxy(init, GTK_TYPE_ENTRY_COMPLETION, GtkEntryCompletionProxy, 0);
	AddProxy(init, GTK_TYPE_ENTRY, GtkEntryProxy, 0);
	AddProxy(init, GTK_TYPE_COMBO_BOX, GtkComboBoxProxy, 0);
	AddProxy(init, GTK_TYPE_COMBO_BOX_ENTRY, GtkComboBoxEntryProxy, 0);
	AddProxy(init, GTK_TYPE_SPIN_BUTTON, GtkSpinButtonProxy, 0);
	AddProxy(init, CROW_TYPE_SCALE_MARK_ENTRY, CrowScaleMarkEntryProxy, 0);
	AddProxy(init, GTK_TYPE_HSCALE, GtkScaleProxy, 0);
	AddProxy(init, GTK_TYPE_VSCALE, GtkScaleProxy, 0);
	AddProxy(init, GTK_TYPE_PROGRESS_BAR, GtkProgressBarProxy, 0);
	AddProxy(init, GTK_TYPE_IMAGE, GtkImageProxy, 0);
	AddProxy(init, GTK_TYPE_HSEPARATOR, GtkSeparatorProxy, 0);
	AddProxy(init, GTK_TYPE_VSEPARATOR, GtkSeparatorProxy, 0);
	AddProxy(init, GTK_TYPE_SIZE_GROUP, GtkSizeGroupProxy, 1);
	AddProxy(init, GTK_TYPE_TEXT_VIEW, GtkTextViewProxy, 0);
	AddProxy(init, GTK_TYPE_ICON_VIEW, GtkIconViewProxy, 0);
	AddProxy(init, GTK_TYPE_CELL_VIEW, GtkCellViewProxy, 0);
	AddProxy(init, GTK_TYPE_TREE_VIEW, GtkTreeViewProxy, 0);
	AddProxy(init, GTK_TYPE_COLOR_BUTTON, GtkColorButtonProxy, 0);
	AddProxy(init, GTK_TYPE_COLOR_SELECTION, GtkColorSelectionProxy, 0);
	AddProxy(init, GTK_TYPE_FILE_CHOOSER_BUTTON, GtkFileChooserButtonProxy, 0);
	AddProxy(init, GTK_TYPE_FILE_CHOOSER_WIDGET, GtkFileChooserWidgetProxy, 0);
	AddProxy(init, GTK_TYPE_FONT_BUTTON, GtkFontButtonProxy, 0);
	AddProxy(init, GTK_TYPE_FONT_SELECTION, GtkFontSelectionProxy, 0);
	AddProxy(init, GTK_TYPE_FIXED, GtkFixedProxy, 0);
	AddProxy(init, GTK_TYPE_LAYOUT, GtkLayoutProxy, 0);
	AddProxy(init, GTK_TYPE_HSCROLLBAR, GtkScrollbarProxy, 0);
	AddProxy(init, GTK_TYPE_VSCROLLBAR, GtkScrollbarProxy, 0);
	AddProxy(init, GTK_TYPE_EVENT_BOX, GtkEventBoxProxy, 0);
	AddProxy(init, GTK_TYPE_DRAWING_AREA, GtkDrawingAreaProxy, 0);
	AddProxy(init, GTK_TYPE_CALENDAR, GtkCalendarProxy, 0);
	AddProxy(init, GTK_TYPE_ARROW, GtkArrowProxy, 0);
	AddProxy(init, CROW_TYPE_CUSTOM, CrowCustomProxy, 0);
	AddProxy(init, GTK_TYPE_STATUS_ICON, GtkStatusIconProxy, 0);
	AddProxy(init, GTK_TYPE_LINK_BUTTON, GtkLinkButtonProxy, 0);
	AddProxy(init, GTK_TYPE_RECENT_FILTER, GtkRecentFilterProxy, 0);
	AddProxy(init, GTK_TYPE_RECENT_CHOOSER_WIDGET, GtkRecentChooserWidgetProxy, 0);
	AddProxy(init, GTK_TYPE_RECENT_CHOOSER_DIALOG, GtkRecentChooserDialogProxy, 0);
	AddProxy(init, GTK_TYPE_RECENT_ACTION, GtkRecentActionProxy, 0);
	AddProxy(init, GTK_TYPE_SPINNER, GtkSpinnerProxy, 0);
}

void RegisterGType(GType type) {
	CHECK(type);
}

// GObjectProxy ----------------------------------------------------------------

void GObjectProxy(Proxy * proxy) {
	GUILOADER_VIRTUAL_BASE(proxy, vbGObject);
	AddProperty(proxy, "signals", PropertyGObjectSignals);
}

void PropertyGObjectSignals(PropertyFuncData * data) {
	PtrArray * array= ModelGetEmitterVector(data->node);
	int i;
	for(i= 0; i < array->size; ++i) {
		CrowEmitter * emitter= array->ptrs[i];
		AddConnector(data->loader, data->object, emitter);
	}
	PtrArrayFree(array);
}

// CrowRelationEntry -----------------------------------------------------------

GType crow_relation_entry_get_type(void) {
	static GType object_type= 0;
	if(object_type==0) {
		static const GTypeInfo object_info= {
			sizeof(GObjectClass),
			NULL, NULL, NULL, NULL, NULL,
			sizeof(CrowRelationEntry),
			0, (GInstanceInitFunc)crow_relation_entry_init,
		};
		object_type= g_type_register_static(G_TYPE_OBJECT, "CrowRelationEntry", &object_info, 0);
	}
	return object_type;
}

void crow_relation_entry_init(CrowRelationEntry * entry) {
	entry->relation= ATK_RELATION_NULL;
	entry->target= NULL;
}

// CrowRelationEntryProxy ------------------------------------------------------

void CrowRelationEntryProxy(Proxy * proxy) {
	GObjectProxy(proxy);
	AddProperty(proxy, "relation", PropertyCrowRelationEntryRelation);
	AddProperty(proxy, "target", PropertyCrowRelationEntryTarget);
}

void PropertyCrowRelationEntryRelation(PropertyFuncData * data) {
	int value= ModelGetEnum(data->node);
	CROW_RELATION_ENTRY(data->object)->relation= value;
}

void PropertyCrowRelationEntryTarget(PropertyFuncData * data) {
	GObject * value= ModelGetObject(data->loader, data->node, NULL);
	CROW_RELATION_ENTRY(data->object)->target= GTK_WIDGET(value);
}

// GtkWidget -------------------------------------------------------------------

void GtkWidgetProxy(Proxy * proxy) {
	GUILOADER_VIRTUAL_BASE(proxy, vbGtkWidget);
	GObjectProxy(proxy);
	AddInitInstance(proxy, GtkWidgetInit);
	AddProperty(proxy, "size-request", PropertyGtkWidgetSizeRequest);
	AddProperty(proxy, "sensitive", PropertyBool);
	AddProperty(proxy, "visible", PropertyBool);
	AddProperty(proxy, "tooltip", PropertyGtkWidgetTooltip);
	AddProperty(proxy, "atk-name", PropertyGtkWidgetAtkName);
	AddProperty(proxy, "atk-description", PropertyGtkWidgetAtkDescription);
	AddProperty(proxy, "atk-relations", PropertyGtkWidgetAtkRelations);
}

void GtkWidgetInit(GObject * object, Node * node) {
	GtkWidget * widget= GTK_WIDGET(object);
	gtk_widget_set_name(widget, ShortStrGet(node->name));
	if(!GTK_IS_WINDOW(object))
		gtk_widget_show(widget);
}

void PropertyGtkWidgetSizeRequest(PropertyFuncData * data) {
	CrowPoint p= ModelGetPoint(data->node);
	gtk_widget_set_size_request(GTK_WIDGET(data->object), p.x, p.y);
}

void PropertyGtkWidgetTooltip(PropertyFuncData * data) {
	const char * str= ModelGetString(data->node);
	GtkWidget * widget= GTK_WIDGET(data->object);
	CrowTooltipMode mode= CROW_TOOLTIP_TEXT;
	Node * nmode= FindNode(data->node->owner, "tooltip-mode");
	if(nmode)
		mode= ModelGetTooltipMode(nmode);
	switch(mode) {
		case CROW_TOOLTIP_TEXT:
			gtk_widget_set_tooltip_text(widget, str);
			break;
		case CROW_TOOLTIP_MARKUP:
			gtk_widget_set_tooltip_markup(widget, str);
			break;
		case CROW_TOOLTIP_TEXT_OFF:
			gtk_widget_set_tooltip_text(widget, str);
			gtk_widget_set_has_tooltip(widget, FALSE);
			break;
		case CROW_TOOLTIP_MARKUP_OFF:
			gtk_widget_set_tooltip_markup(widget, str);
			gtk_widget_set_has_tooltip(widget, FALSE);
			break;
		default:
			CHECK(FALSE);
	}
}

void PropertyGtkWidgetEvents(PropertyFuncData * data) {
	char * endptr, * str;
	unsigned v;
	CheckNodeScalar(data->node);
	str= ShortStrGet(data->node->text);
	v= strtoul(str, &endptr, 16);
	CHECK(*str!=0 && *endptr==0);
	gtk_widget_add_events(GTK_WIDGET(data->object), v);
}

void PropertyGtkWidgetAtkName(PropertyFuncData * data) {
	const char * str= ModelGetString(data->node);
	AtkObject * atk= gtk_widget_get_accessible(GTK_WIDGET(data->object));
	atk_object_set_name(atk, str);
}

void PropertyGtkWidgetAtkDescription(PropertyFuncData * data) {
	const char * str= ModelGetString(data->node);
	AtkObject * atk= gtk_widget_get_accessible(GTK_WIDGET(data->object));
	atk_object_set_description(atk, str);
}

void PropertyGtkWidgetAtkRelations(PropertyFuncData * data) {
	AtkObject * atk= gtk_widget_get_accessible(GTK_WIDGET(data->object));
	AtkRelationSet * set= atk_object_ref_relation_set(atk);
	PtrArray * array= ModelGetObjectVector(data->loader, data->node);
	int i;
	for(i= 0; i < array->size; ++i)
		if(array->ptrs[i]) {
			CrowRelationEntry * entry= CROW_RELATION_ENTRY(array->ptrs[i]);
			if(entry->target && entry->relation!=ATK_RELATION_NULL) {
				AtkObject * target= gtk_widget_get_accessible(entry->target);
				atk_relation_set_add_relation_by_type(set, entry->relation, target);
			}
		}
	PtrArrayFree(array);
}

void GtkWidgetAddReceivesDefaultProperty(Proxy * proxy) {
	AddProperty(proxy, "receives-default", PropertyBool);
}

void GtkWidgetAddCanFocusProperty(Proxy * proxy) {
	AddProperty(proxy, "can-focus", PropertyBool);
}

void GtkWidgetAddCanDefaultProperty(Proxy * proxy) {
	AddProperty(proxy, "can-default", PropertyBool);
}

void GtkWidgetAddAppPaintableProperty(Proxy * proxy) {
	AddProperty(proxy, "app-paintable", PropertyBool);
}

void GtkWidgetAddEventProperties(Proxy * proxy) {
	AddProperty(proxy, "events", PropertyGtkWidgetEvents);
	AddProperty(proxy, "extension-events", PropertyEnum);
}

void GtkWidgetAddOrientationProperty(Proxy * proxy) {
	AddProperty(proxy, "orientation", PropertyEnum);
}

// GtkContainerProxyBase -------------------------------------------------------

void GtkContainerProxyBase(Proxy * proxy) {
	GtkWidgetProxy(proxy);
	AddProperty(proxy, "border-width", PropertyUnsigned);
}

// GtkContainerProxy -----------------------------------------------------------

void GtkContainerProxy(Proxy * proxy) {
	GUILOADER_VIRTUAL_BASE(proxy, vbGtkContainer);
	GtkContainerProxyBase(proxy);
	AddProperty(proxy, "children", NULL);
	AddProperty(proxy, "focus-chain", PropertyGtkContainerFocusChain) -> lazy = TRUE;
}

void GtkContainerSetChildrenPropertyFunc(Proxy * proxy, PropertyFunc func) {
	Property * prop= FindProperty(proxy, "children");
	prop->assign= func;
}

gboolean GtkContainerVerifyChild(GtkWidget * container, GtkWidget * child) {
	if(child && gtk_widget_get_parent(child) != container) {
		g_warning(_("%s.focus-chain has not a direct child"), gtk_widget_get_name(container));
		return FALSE;
	} else
		return TRUE;
}

void PropertyGtkContainerFocusChain(PropertyFuncData * data) {
	PtrArray * array= ModelGetObjectVector(data->loader, data->node);
	gboolean do_set= TRUE;
	GList * chain;
	if(GUI_LOADER_GET_PRIVATE(data->loader)->preview) {
		int i;
		for(i= 0; i<array->size && do_set; ++i)
			do_set= GtkContainerVerifyChild(GTK_WIDGET(data->object), GTK_WIDGET(array->ptrs[i]));
	}
	if(do_set) {
		chain= CreateListFromPtrArray(array);
		gtk_container_set_focus_chain(GTK_CONTAINER(data->object), chain);
		g_list_free(chain);
	}
	PtrArrayFree(array);
}

// CrowChildProxy --------------------------------------------------------------

void CrowChildProxy(Proxy * proxy) {
	GObjectProxy(proxy);
	AddProperty(proxy, "widget", PropertyCrowChildWidget);
}

void PropertyCrowChildWidget(PropertyFuncData * data) {
	GObject * widget= ModelGetObject(data->loader, data->node, NULL);
	CROW_CHILD(data->object)->widget= GTK_WIDGET(widget);
}

void CrowChildAddIndexProperty(Proxy * proxy) {
	AddProperty(proxy, "index", PropertyCrowChildIndex);
}

void PropertyCrowChildIndex(PropertyFuncData * data) {
	int value= ModelGetInt(data->node);
	CROW_CHILD(data->object)->place.a= value;
}

// GtkBinProxy -----------------------------------------------------------------

void GtkBinProxy(Proxy * proxy) {
	GtkContainerProxy(proxy);
	GtkContainerSetChildrenPropertyFunc(proxy, PropertyGtkBinChildren);
}

void PropertyGtkBinChildren(PropertyFuncData * data) {
	PtrArray * children;
	CheckNodeVector(data->node);
	children= ModelGetObjectVector(data->loader, data->node);
	ContainerBinSet(GTK_BIN(data->object), children);
	PtrArrayFree(children);
}

// GtkAlignmentProxy -----------------------------------------------------------

void GtkAlignmentProxy(Proxy * proxy) {
	GtkBinProxy(proxy);
	AddProperty(proxy, "bottom-padding", PropertyUnsigned);
	AddProperty(proxy, "left-padding", PropertyUnsigned);
	AddProperty(proxy, "right-padding", PropertyUnsigned);
	AddProperty(proxy, "top-padding", PropertyUnsigned);
	AddProperty(proxy, "xalign", PropertyFloat);
	AddProperty(proxy, "xscale", PropertyFloat);
	AddProperty(proxy, "yalign", PropertyFloat);
	AddProperty(proxy, "yscale", PropertyFloat);
}

// GtkFrameProxy ---------------------------------------------------------------

void GtkFrameProxy(Proxy * proxy) {
	GtkBinProxy(proxy);
	AddProperty(proxy, "label-widget-set", PropertyGtkFrameLabelWidgetSet);
	AddProperty(proxy, "label", PropertyGtkFrameLabel);
	AddProperty(proxy, "label-widget", PropertyObject);
	AddProperty(proxy, "label-xalign", PropertyFloat);
	AddProperty(proxy, "label-yalign", PropertyFloat);
	AddProperty(proxy, "shadow-type", PropertyEnum);
}

void PropertyGtkFrameLabelWidgetSet(PropertyFuncData * data) {
	gboolean set= ModelGetBool(data->node);
	if(!set)
		gtk_frame_set_label(GTK_FRAME(data->object), "");
}

void PropertyGtkFrameLabel(PropertyFuncData * data) {
	const char * str= ModelGetString(data->node);
	GtkWidget * widget= gtk_frame_get_label_widget(GTK_FRAME(data->object));
	CHECK(GTK_IS_LABEL(widget));
	gtk_label_set_label(GTK_LABEL(widget), str);
}

// GtkAspectFrameProxy ---------------------------------------------------------

void GtkAspectFrameProxy(Proxy * proxy) {
	GtkFrameProxy(proxy);
	AddInitInstance(proxy, GtkAspectFrameInit);
	AddProperty(proxy, "obey-child", PropertyBool);
	AddProperty(proxy, "ratio", PropertyFloat);
	AddProperty(proxy, "xalign", PropertyFloat);
	AddProperty(proxy, "yalign", PropertyFloat);
}

void GtkAspectFrameInit(GObject * object, Node * node) {
	gtk_aspect_frame_set(GTK_ASPECT_FRAME(object), 0.5f, 0.5f, 0.5f, TRUE);
}

// GtkExpanderProxy ------------------------------------------------------------

void GtkExpanderProxy(Proxy * proxy) {
	GtkBinProxy(proxy);
	AddInitInstance(proxy, GtkExpanderInit);
	GtkWidgetAddCanFocusProperty(proxy);
	AddProperty(proxy, "label", PropertyGtkExpanderLabel);
	AddProperty(proxy, "label-widget", PropertyObject);
	AddProperty(proxy, "expanded", PropertyBool);
	AddProperty(proxy, "spacing", PropertyInt);
}

void GtkExpanderInit(GObject * object, Node * node) {
	Node * set= FindNode(node, "label-widget-set");
	if(!set || !ModelGetBool(set))
		gtk_expander_set_label(GTK_EXPANDER(object), "");
}

void PropertyGtkExpanderLabel(PropertyFuncData * data) {
	const char * str= ModelGetString(data->node);
	GtkWidget * widget= gtk_expander_get_label_widget(GTK_EXPANDER(data->object));
	CHECK(GTK_IS_LABEL(widget));
	gtk_label_set_label(GTK_LABEL(widget), str);
}

// GtkScrolledWindowProxy ------------------------------------------------------

void GtkScrolledWindowProxy(Proxy * proxy) {
	GtkBinProxy(proxy);
	GtkContainerSetChildrenPropertyFunc(proxy, PropertyGtkScrolledWindowChildren);
	GtkWidgetAddCanFocusProperty(proxy);
	AddProperty(proxy, "hadjustment", PropertyObject);
	AddProperty(proxy, "vadjustment", PropertyObject);
	AddProperty(proxy, "shadow-type", PropertyEnum);
	AddProperty(proxy, "hscrollbar-policy", PropertyEnum);
	AddProperty(proxy, "vscrollbar-policy", PropertyEnum);
	AddProperty(proxy, "window-placement-set", PropertyBool);
	AddProperty(proxy, "window-placement", PropertyEnum);
	AddProperty(proxy, "auto-viewport", PropertyGtkScrolledWindowAutoViewport);
}

void PropertyGtkScrolledWindowChildren(PropertyFuncData * data) {
	PtrArray * children= ModelGetObjectVector(data->loader, data->node);
	ContainerScrolledWindowSet(GTK_SCROLLED_WINDOW(data->object), children);
	PtrArrayFree(children);
}

void PropertyGtkScrolledWindowAutoViewport(PropertyFuncData * data) {
	GObject * widget= G_OBJECT(gtk_bin_get_child(GTK_BIN(data->object)));
	CHECK(widget && g_object_get_data(widget, "CrowAutoViewportHint"));
	ModelGetObject(data->loader, data->node, widget);
}

// GtkHandleBoxProxy -----------------------------------------------------------

void GtkHandleBoxProxy(Proxy * proxy) {
	GtkBinProxy(proxy);
	AddInitInstance(proxy, GtkHandleBoxInit);
	GtkWidgetAddEventProperties(proxy);
	AddProperty(proxy, "handle-position", PropertyEnum);
	AddProperty(proxy, "shadow-type", PropertyEnum);
	AddProperty(proxy, "snap-edge-set", PropertyBool);
	AddProperty(proxy, "snap-edge", PropertyEnum);
}

void GtkHandleBoxInit(GObject * object, Node * node) {
	gtk_handle_box_set_shadow_type(GTK_HANDLE_BOX(object), GTK_SHADOW_ETCHED_OUT);
}

// GtkViewportProxy ------------------------------------------------------------

void GtkViewportProxy(Proxy * proxy) {
	GtkBinProxy(proxy);
	GtkWidgetAddEventProperties(proxy);
	AddProperty(proxy, "shadow-type", PropertyEnum);
}

// CrowBoxChildProxy -----------------------------------------------------------

void CrowBoxChildProxy(Proxy * proxy) {
	CrowChildProxy(proxy);
	CrowChildAddIndexProperty(proxy);
	AddProperty(proxy, "pack", PropertyCrowBoxChildPack);
	AddProperty(proxy, "options", PropertyCrowBoxChildOptions);
	AddProperty(proxy, "padding", PropertyCrowBoxChildPadding);
}

void PropertyCrowBoxChildPack(PropertyFuncData * data) {
	int value= ModelGetInt(data->node);
	CROW_CHILD(data->object)->place.b= value;
}

void PropertyCrowBoxChildOptions(PropertyFuncData * data) {
	CrowPackOptions value= ModelGetPackOptions(data->node);
	CROW_BOX_CHILD(data->object)->options= value;
}

void PropertyCrowBoxChildPadding(PropertyFuncData * data) {
	unsigned value= ModelGetUnsigned(data->node);
	CROW_BOX_CHILD(data->object)->padding= value;
}

// GtkBoxProxy -----------------------------------------------------------------

void GtkBoxProxy(Proxy * proxy) {
	GtkContainerProxy(proxy);
	GtkContainerSetChildrenPropertyFunc(proxy, PropertyGtkBoxChildren);
	GtkWidgetAddOrientationProperty(proxy);
	AddProperty(proxy, "capacity", PropertyGtkBoxCapacity);
	AddProperty(proxy, "homogeneous", PropertyBool);
	AddProperty(proxy, "spacing", PropertyInt);
}

void PropertyGtkBoxChildren(PropertyFuncData * data) {
	PtrArray * children= ModelGetObjectVector(data->loader, data->node);
	CrowPoint cap= { 0, 0 };
	Node * ncap= FindNode(data->node->owner, "capacity");
	if(ncap)
		cap= ModelGetPoint(ncap);
	ContainerBoxSet(GTK_BOX(data->object), children, cap.x, cap.y);
	PtrArrayFree(children);
}

void PropertyGtkBoxCapacity(PropertyFuncData * data) {
	if(ContainerIsEmpty(GTK_CONTAINER(data->object))) {
		CrowPoint cap= ModelGetPoint(data->node);
		ContainerBoxSet(GTK_BOX(data->object), NULL, cap.x, cap.y);
	}
}

// CrowButtonBoxChildProxy -----------------------------------------------------

void CrowButtonBoxChildProxy(Proxy * proxy) {
	CrowBoxChildProxy(proxy);
	AddProperty(proxy, "secondary", PropertyCrowButtonBoxChildSecondary);
}

void PropertyCrowButtonBoxChildSecondary(PropertyFuncData * data) {
	gboolean value= ModelGetBool(data->node);
	CROW_BUTTON_BOX_CHILD(data->object)->secondary= value;
}

// GtkButtonBoxProxy -----------------------------------------------------------

void GtkButtonBoxProxy(Proxy * proxy) {
	GtkBoxProxy(proxy);
	GtkContainerSetChildrenPropertyFunc(proxy, PropertyGtkButtonBoxChildren);
	FindProperty(proxy, "capacity")->assign= PropertyGtkButtonBoxCapacity;
	AddProperty(proxy, "layout-style", PropertyEnum);
}

void PropertyGtkButtonBoxChildren(PropertyFuncData * data) {
	PtrArray * children= ModelGetObjectVector(data->loader, data->node);
	CrowPoint cap= { 0, };
	Node * ncap= FindNode(data->node->owner, "capacity");
	if(ncap)
		cap= ModelGetPoint(ncap);
	ContainerButtonBoxSet(GTK_BUTTON_BOX(data->object), children, cap.x, cap.y);
	PtrArrayFree(children);
}

void PropertyGtkButtonBoxCapacity(PropertyFuncData * data) {
	if(ContainerIsEmpty(GTK_CONTAINER(data->object))) {
		CrowPoint cap= ModelGetPoint(data->node);
		ContainerButtonBoxSet(GTK_BUTTON_BOX(data->object), NULL, cap.x, cap.y);
	}
}

// CrowPanedChildProxy ---------------------------------------------------------

void CrowPanedChildProxy(Proxy * proxy) {
	CrowChildProxy(proxy);
	CrowChildAddIndexProperty(proxy);
	AddProperty(proxy, "resize", PropertyCrowPanedChildResize);
	AddProperty(proxy, "shrink", PropertyCrowPanedChildShrink);
}

void PropertyCrowPanedChildResize(PropertyFuncData * data) {
	gboolean value= ModelGetBool(data->node);
	CROW_PANED_CHILD(data->object)->resize= value;
}

void PropertyCrowPanedChildShrink(PropertyFuncData * data) {
	gboolean value= ModelGetBool(data->node);
	CROW_PANED_CHILD(data->object)->shrink= value;
}

// GtkPanedProxy ---------------------------------------------------------------

void GtkPanedProxy(Proxy * proxy) {
	GtkContainerProxy(proxy);
	GtkContainerSetChildrenPropertyFunc(proxy, PropertyGtkPanedChildren);
	GtkWidgetAddCanFocusProperty(proxy);
	GtkWidgetAddOrientationProperty(proxy);
	AddProperty(proxy, "position-set", PropertyBool);
	AddProperty(proxy, "position", PropertyInt);
}

void PropertyGtkPanedChildren(PropertyFuncData * data) {
	PtrArray * children= ModelGetObjectVector(data->loader, data->node);
	ContainerPanedSet(GTK_PANED(data->object), children);
	PtrArrayFree(children);
}

// CrowNotebookChildProxy ------------------------------------------------------

void CrowNotebookChildProxy(Proxy * proxy) {
	CrowChildProxy(proxy);
	CrowChildAddIndexProperty(proxy);
	AddProperty(proxy, "tab-label", PropertyCrowNotebookChildTabLabel);
	AddProperty(proxy, "tab-label-widget", PropertyCrowNotebookChildTabLabelWidget);
	AddProperty(proxy, "menu-label", PropertyCrowNotebookChildMenuLabel);
	AddProperty(proxy, "menu-label-widget", PropertyCrowNotebookChildMenuLabelWidget);
	AddProperty(proxy, "pack-options", PropertyCrowNotebookChildPackOptions);
	AddProperty(proxy, "detachable", PropertyCrowNotebookChildDetachable);
	AddProperty(proxy, "reorderable", PropertyCrowNotebookChildReorderable);
}

void PropertyCrowNotebookChildTabLabel(PropertyFuncData * data) {
	const char * value= ModelGetString(data->node);
	CROW_NOTEBOOK_CHILD(data->object)->tabLabel= value;
}

void PropertyCrowNotebookChildTabLabelWidget(PropertyFuncData * data) {
	GObject * value= ModelGetObject(data->loader, data->node, NULL);
	CROW_NOTEBOOK_CHILD(data->object)->tabLabelWidget= GTK_WIDGET(value);
}

void PropertyCrowNotebookChildMenuLabel(PropertyFuncData * data) {
	const char * value= ModelGetString(data->node);
	CROW_NOTEBOOK_CHILD(data->object)->menuLabel= value;
}

void PropertyCrowNotebookChildMenuLabelWidget(PropertyFuncData * data) {
	GObject * value= ModelGetObject(data->loader, data->node, NULL);
	CROW_NOTEBOOK_CHILD(data->object)->menuLabelWidget= GTK_WIDGET(value);
}

void PropertyCrowNotebookChildPackOptions(PropertyFuncData * data) {
	CrowPackOptions value= ModelGetPackOptions(data->node);
	CROW_NOTEBOOK_CHILD(data->object)->packOptions= value;
}

void PropertyCrowNotebookChildDetachable(PropertyFuncData * data) {
	gboolean value= ModelGetBool(data->node);
	CROW_NOTEBOOK_CHILD(data->object)->detachable= value;
}

void PropertyCrowNotebookChildReorderable(PropertyFuncData * data) {
	gboolean value= ModelGetBool(data->node);
	CROW_NOTEBOOK_CHILD(data->object)->reorderable= value;
}

// GtkNotebookProxy ------------------------------------------------------------

void GtkNotebookProxy(Proxy * proxy) {
	GtkContainerProxy(proxy);
	GtkContainerSetChildrenPropertyFunc(proxy, PropertyGtkNotebookChildren);
	AddProperty(proxy, "capacity", PropertyGtkNotebookCapacity);
	GtkWidgetAddCanFocusProperty(proxy);
	AddProperty(proxy, "enable-popup", PropertyBool);
	AddProperty(proxy, "homogeneous", PropertyBool);
	AddProperty(proxy, "page", PropertyGtkNotebookPage);
	AddProperty(proxy, "scrollable", PropertyBool);
	AddProperty(proxy, "show-border", PropertyBool);
	AddProperty(proxy, "show-tabs", PropertyBool);
	AddProperty(proxy, "tab-hborder", PropertyUnsigned);
	AddProperty(proxy, "tab-vborder", PropertyUnsigned);
	AddProperty(proxy, "tab-pos", PropertyEnum);
	AddProperty(proxy, "group-id", PropertyInt);
	AddProperty(proxy, "action-widget-start", PropertyGtkNotebookActionWidgetStart);
	AddProperty(proxy, "action-widget-end", PropertyGtkNotebookActionWidgetEnd);
}

void PropertyGtkNotebookChildren(PropertyFuncData * data) {
	PtrArray * children= ModelGetObjectVector(data->loader, data->node);
	int cap= 0;
	Node * ncap= FindNode(data->node->owner, "capacity");
	if(ncap)
		cap= ModelGetInt(ncap);
	ContainerNotebookSet(GTK_NOTEBOOK(data->object), children, cap);
	PtrArrayFree(children);
}

void PropertyGtkNotebookCapacity(PropertyFuncData * data) {
	if(ContainerIsEmpty(GTK_CONTAINER(data->object))) {
		int cap= ModelGetInt(data->node);
		ContainerNotebookSet(GTK_NOTEBOOK(data->object), NULL, cap);
	}
}

void PropertyGtkNotebookPage(PropertyFuncData * data) {
	int value= ModelGetInt(data->node);
	if(value > 0 && GUI_LOADER_GET_PRIVATE(data->loader)->preview)
		gtk_notebook_set_current_page(GTK_NOTEBOOK(data->object), value);
}

void PropertyGtkNotebookActionWidgetStart(PropertyFuncData * data) {
	GtkWidget * widget= GTK_WIDGET(ModelGetObject(data->loader, data->node, NULL));
	gtk_notebook_set_action_widget(GTK_NOTEBOOK(data->object), widget, GTK_PACK_START);
}

void PropertyGtkNotebookActionWidgetEnd(PropertyFuncData * data) {
	GtkWidget * widget= GTK_WIDGET(ModelGetObject(data->loader, data->node, NULL));
	gtk_notebook_set_action_widget(GTK_NOTEBOOK(data->object), widget, GTK_PACK_END);
}

// CrowTableChildProxy ---------------------------------------------------------

void CrowTableChildProxy(Proxy * proxy) {
	CrowChildProxy(proxy);
	AddProperty(proxy, "cell", PropertyCrowTableChildCell);
	AddProperty(proxy, "cell-span", PropertyCrowTableChildCellSpan);
	AddProperty(proxy, "padding-x", PropertyCrowTableChildPaddingX);
	AddProperty(proxy, "padding-y", PropertyCrowTableChildPaddingY);
	AddProperty(proxy, "x-expand", PropertyCrowTableChildXExpand);
	AddProperty(proxy, "x-fill", PropertyCrowTableChildXFill);
	AddProperty(proxy, "x-shrink", PropertyCrowTableChildXShrink);
	AddProperty(proxy, "y-expand", PropertyCrowTableChildYExpand);
	AddProperty(proxy, "y-fill", PropertyCrowTableChildYFill);
	AddProperty(proxy, "y-shrink", PropertyCrowTableChildYShrink);
}

void PropertyCrowTableChildCell(PropertyFuncData * data) {
	CrowPoint value= ModelGetPoint(data->node);
	CROW_CHILD(data->object)->place.a= value.x;
	CROW_CHILD(data->object)->place.b= value.y;
}

void PropertyCrowTableChildCellSpan(PropertyFuncData * data) {
	CrowPoint value= ModelGetPoint(data->node);
	CROW_CHILD(data->object)->place.c= value.x;
	CROW_CHILD(data->object)->place.d= value.y;
}

void PropertyCrowTableChildPaddingX(PropertyFuncData * data) {
	unsigned value= ModelGetUnsigned(data->node);
	CROW_TABLE_CHILD(data->object)->paddingX= value;
}

void PropertyCrowTableChildPaddingY(PropertyFuncData * data) {
	unsigned value= ModelGetUnsigned(data->node);
	CROW_TABLE_CHILD(data->object)->paddingY= value;
}

void PropertyCrowTableChildXExpand(PropertyFuncData * data) {
	gboolean value= ModelGetBool(data->node);
	CROW_TABLE_CHILD(data->object)->xExpand= value;
}

void PropertyCrowTableChildXFill(PropertyFuncData * data) {
	gboolean value= ModelGetBool(data->node);
	CROW_TABLE_CHILD(data->object)->xFill= value;
}

void PropertyCrowTableChildXShrink(PropertyFuncData * data) {
	gboolean value= ModelGetBool(data->node);
	CROW_TABLE_CHILD(data->object)->xShrink= value;
}

void PropertyCrowTableChildYExpand(PropertyFuncData * data) {
	gboolean value= ModelGetBool(data->node);
	CROW_TABLE_CHILD(data->object)->yExpand= value;
}

void PropertyCrowTableChildYFill(PropertyFuncData * data) {
	gboolean value= ModelGetBool(data->node);
	CROW_TABLE_CHILD(data->object)->yFill= value;
}

void PropertyCrowTableChildYShrink(PropertyFuncData * data) {
	gboolean value= ModelGetBool(data->node);
	CROW_TABLE_CHILD(data->object)->yShrink= value;
}

// GtkTableProxy ---------------------------------------------------------------

void GtkTableProxy(Proxy * proxy) {
	GtkContainerProxy(proxy);
	SetCreateInstance(proxy, GtkTableCreate);
	GtkContainerSetChildrenPropertyFunc(proxy, PropertyGtkTableChildren);
	AddProperty(proxy, "capacity", PropertyGtkTableCapacity);
	AddProperty(proxy, "column-spacing", PropertyUnsigned);
	AddProperty(proxy, "homogeneous", PropertyBool);
	AddProperty(proxy, "row-spacing", PropertyUnsigned);
}

GObject * GtkTableCreate(GuiLoader * loader, Node * node) {
	return G_OBJECT(gtk_table_new(1, 1, FALSE));
}

void PropertyGtkTableChildren(PropertyFuncData * data) {
	PtrArray * children= ModelGetObjectVector(data->loader, data->node);
	CrowPoint cap= { 1, 1 };
	Node * ncap= FindNode(data->node->owner, "capacity");
	if(ncap)
		cap= ModelGetPoint(ncap);
	ContainerTableSet(GTK_TABLE(data->object), children, cap.x, cap.y);
	PtrArrayFree(children);
}

void PropertyGtkTableCapacity(PropertyFuncData * data) {
	if(ContainerIsEmpty(GTK_CONTAINER(data->object))) {
		CrowPoint cap= ModelGetPoint(data->node);
		ContainerTableSet(GTK_TABLE(data->object), NULL, cap.x, cap.y);
	}
}

// CrowXYChild -----------------------------------------------------------------

void CrowXYChildProxy(Proxy * proxy) {
	CrowChildProxy(proxy);
	AddProperty(proxy, "xy", PropertyCrowXYChildXY);
}

void PropertyCrowXYChildXY(PropertyFuncData * data) {
	CrowPoint value= ModelGetPoint(data->node);
	CROW_CHILD(data->object)->place.a= value.x;
	CROW_CHILD(data->object)->place.b= value.y;
}

// GtkAdjustmentProxy ----------------------------------------------------------

void GtkAdjustmentProxy(Proxy * proxy) {
	GObjectProxy(proxy);
	AddProperty(proxy, "lower", PropertyDouble);
	AddProperty(proxy, "upper", PropertyDouble);
	AddProperty(proxy, "page-size", PropertyDouble);
	AddProperty(proxy, "page-increment", PropertyDouble);
	AddProperty(proxy, "step-increment", PropertyDouble);
	AddProperty(proxy, "value", PropertyDouble);
}

// GtkWindowProxyBase ----------------------------------------------------------

void GtkWindowProxyBase(Proxy * proxy) {
	GtkWidgetAddEventProperties(proxy);
	AddProperty(proxy, "accept-focus", PropertyBool);
	AddProperty(proxy, "default-size", PropertyGtkWindowBaseDefaultSize);
	AddProperty(proxy, "focus-on-map", PropertyBool);
	AddProperty(proxy, "gravity", PropertyEnum);
	AddProperty(proxy, "icon-name", PropertyString);
	AddProperty(proxy, "modal", PropertyBool);
	AddProperty(proxy, "resizable", PropertyBool);
	AddProperty(proxy, "role", PropertyString);
	AddProperty(proxy, "skip-pager-hint", PropertyBool);
	AddProperty(proxy, "skip-taskbar-hint", PropertyBool);
	AddProperty(proxy, "title", PropertyString);
	AddProperty(proxy, "window-position", PropertyEnum);
	AddProperty(proxy, "transient-for", PropertyObject);
	AddProperty(proxy, "accel-groups", PropertyGtkWindowBaseAccelGroups);
	AddProperty(proxy, "urgency-hint", PropertyBool);
	AddProperty(proxy, "deletable", PropertyBool);
	AddProperty(proxy, "opacity", PropertyDouble);
	AddProperty(proxy, "type-hint", PropertyEnum);
}

void PropertyGtkWindowBaseDefaultSize(PropertyFuncData * data) {
	CrowPoint value= ModelGetPoint(data->node);
	gtk_window_set_default_size(GTK_WINDOW(data->object), value.x, value.y);
}

void PropertyGtkWindowBaseAccelGroups(PropertyFuncData * data) {
	GtkWindow * window= GTK_WINDOW(data->object);
	PtrArray * array= ModelGetObjectVector(data->loader, data->node);
	int i;
	for(i= 0; i < array->size; ++i)
		if(array->ptrs[i]) {
			GtkUIManager * manager= GTK_UI_MANAGER(array->ptrs[i]);
			gtk_window_add_accel_group(window, gtk_ui_manager_get_accel_group(manager));
		}
	PtrArrayFree(array);
}

// GtkWindowProxy --------------------------------------------------------------

void GtkWindowProxy(Proxy * proxy) {
	GtkBinProxy(proxy);
	GtkWindowProxyBase(proxy);
	SetCreateInstance(proxy, GtkWindowCreate);
	GtkWidgetAddAppPaintableProperty(proxy);
	AddProperty(proxy, "decorated", PropertyBool);
	AddProperty(proxy, "default", PropertyGtkWindowDefault);
}

GObject * GtkWindowCreate(GuiLoader * loader, Node * node) {
	GtkWindowType type= GTK_WINDOW_TOPLEVEL;
	GObject * object;
	if(!GUI_LOADER_GET_PRIVATE(loader)->preview) {
		Node * set= FindNode(node, "type");
		if(set && ModelGetEnum(set)==GTK_WINDOW_POPUP)
			type= GTK_WINDOW_POPUP;
	}
	object= G_OBJECT(gtk_window_new(type));
	GtkWindowConnectDeleteEvent(object);
	return object;
}

void GtkWindowConnectDeleteEvent(GObject * window) {
	gulong hid= g_signal_connect(window, "delete-event", G_CALLBACK(GtkWindowOnDeleteEvent), NULL);
	g_object_set_data(window, "GuiLoaderOnDeleteEvent", GUINT_TO_POINTER(hid));
}

gboolean GtkWindowOnDeleteEvent(GObject * window) {
	gulong hid= GPOINTER_TO_UINT(g_object_get_data(window, "GuiLoaderOnDeleteEvent"));
	guint sid;
	gboolean pending;
	CHECK(hid);
	g_signal_handler_block(window, hid);
	sid= g_signal_lookup("delete-event", GTK_TYPE_WINDOW);
	pending= g_signal_has_handler_pending(window, sid, 0, FALSE);
	if(!pending)
		gtk_widget_hide(GTK_WIDGET(window));
	g_signal_handler_unblock(window, hid);
	return !pending;
}

void PropertyGtkWindowDefault(PropertyFuncData * data) {
	GObject * value= ModelGetObject(data->loader, data->node, NULL);
	gtk_window_set_default(GTK_WINDOW(data->object), GTK_WIDGET(value));
}

// CrowAssistantChildProxy -----------------------------------------------------

void CrowAssistantChildProxy(Proxy * proxy) {
	CrowChildProxy(proxy);
	CrowChildAddIndexProperty(proxy);
	AddProperty(proxy, "page-type", PropertyCrowAssistantChildPageType);
	AddProperty(proxy, "complete", PropertyCrowAssistantChildComplete);
	AddProperty(proxy, "title", PropertyCrowAssistantChildTitle);
	AddProperty(proxy, "header-image", PropertyCrowAssistantChildHeaderImage);
	AddProperty(proxy, "sidebar-image", PropertyCrowAssistantChildSidebarImage);
}

void PropertyCrowAssistantChildPageType(PropertyFuncData * data) {
	int value= ModelGetEnum(data->node);
	CROW_ASSISTANT_CHILD(data->object)->pageType= value;
}

void PropertyCrowAssistantChildComplete(PropertyFuncData * data) {
	gboolean value= ModelGetBool(data->node);
	CROW_ASSISTANT_CHILD(data->object)->complete= value;
}

void PropertyCrowAssistantChildTitle(PropertyFuncData * data) {
	const char * value= ModelGetString(data->node);
	CROW_ASSISTANT_CHILD(data->object)->title= value;
}

void PropertyCrowAssistantChildHeaderImage(PropertyFuncData * data) {
	const char * value= ModelGetString(data->node);
	CROW_ASSISTANT_CHILD(data->object)->headerImage= value;
}

void PropertyCrowAssistantChildSidebarImage(PropertyFuncData * data) {
	const char * value= ModelGetString(data->node);
	CROW_ASSISTANT_CHILD(data->object)->sidebarImage= value;
}

// GtkAssistantProxy -----------------------------------------------------------

void GtkAssistantProxy(Proxy * proxy) {
	GtkContainerProxy(proxy);
	GtkWindowProxyBase(proxy);
	SetCreateInstance(proxy, GtkAssistantCreate);
	GtkContainerSetChildrenPropertyFunc(proxy, PropertyGtkAssistantChildren);
	AddProperty(proxy, "capacity", PropertyGtkAssistantCapacity);
	AddProperty(proxy, "page", PropertyGtkAssistantPage);
	AddProperty(proxy, "buttons", PropertyGtkAssistantButtons);
}

GObject * GtkAssistantCreate(GuiLoader * loader, Node * node) {
	GObject * object= G_OBJECT(gtk_assistant_new());
	GtkWindowConnectDeleteEvent(object);
	if(GUI_LOADER_GET_PRIVATE(loader)->preview)
		g_signal_connect(object, "show", G_CALLBACK(GtkAssistantSetPage), NULL);
	return object;
}

void GtkAssistantSetPage(GtkAssistant * widget, gpointer data) {
	int value= GPOINTER_TO_INT(g_object_get_data(G_OBJECT(widget), "CrowAssistantPage"));
	if(value > 0)
		gtk_assistant_set_current_page(widget, value);
}

void PropertyGtkAssistantChildren(PropertyFuncData * data) {
	PtrArray * children= ModelGetObjectVector(data->loader, data->node);
	int cap= 0;
	Node * ncap= FindNode(data->node->owner, "capacity");
	if(ncap)
		cap= ModelGetInt(ncap);
	ContainerAssistantSet(GTK_ASSISTANT(data->object), children, cap);
	PtrArrayFree(children);
}

void PropertyGtkAssistantCapacity(PropertyFuncData * data) {
	if(ContainerIsEmpty(GTK_CONTAINER(data->object))) {
		int cap= ModelGetInt(data->node);
		ContainerAssistantSet(GTK_ASSISTANT(data->object), NULL, cap);
	}
}

void PropertyGtkAssistantPage(PropertyFuncData * data) {
	int value= ModelGetInt(data->node);
	if(value > 0 && GUI_LOADER_GET_PRIVATE(data->loader)->preview)
		g_object_set_data(G_OBJECT(data->object), "CrowAssistantPage", GINT_TO_POINTER(value));
}

void PropertyGtkAssistantButtons(PropertyFuncData * data) {
	GtkAssistant * assistant= GTK_ASSISTANT(data->object);
	PtrArray * array= ModelGetObjectVector(data->loader, data->node);
	int i;
	for(i= 0; i < array->size; ++i)
		if(array->ptrs[i]) {
			GtkWidget * button= GTK_WIDGET(array->ptrs[i]);
			if(button)
				gtk_assistant_add_action_widget(assistant, button);
		}
	PtrArrayFree(array);
}

// CrowDialogButtonEntry -------------------------------------------------------

GType crow_dialog_button_entry_get_type(void) {
	static GType object_type= 0;
	if(object_type==0) {
		static const GTypeInfo object_info= {
			sizeof(GObjectClass),
			NULL, NULL, NULL, NULL, NULL,
			sizeof(CrowDialogButtonEntry),
			0, (GInstanceInitFunc)crow_dialog_button_entry_init,
		};
		object_type= g_type_register_static(G_TYPE_OBJECT, "CrowDialogButtonEntry", &object_info, 0);
	}
	return object_type;
}

void crow_dialog_button_entry_init(CrowDialogButtonEntry * entry) {
	entry->widget= NULL;
	entry->response= GTK_RESPONSE_NONE;
	entry->secondary= FALSE;
}

// CrowDialogButtonEntryProxy --------------------------------------------------

void CrowDialogButtonEntryProxy(Proxy * proxy) {
	GObjectProxy(proxy);
	AddProperty(proxy, "widget", PropertyCrowDialogButtonEntryWidget);
	AddProperty(proxy, "response", PropertyCrowDialogButtonEntryResponse);
	AddProperty(proxy, "secondary", PropertyCrowDialogButtonEntrySecondary);
}

void PropertyCrowDialogButtonEntryWidget(PropertyFuncData * data) {
	GObject * value= ModelGetObject(data->loader, data->node, NULL);
	CROW_DIALOG_BUTTON_ENTRY(data->object)->widget= GTK_WIDGET(value);
}

void PropertyCrowDialogButtonEntryResponse(PropertyFuncData * data) {
	int value= ModelGetEnum(data->node);
	CROW_DIALOG_BUTTON_ENTRY(data->object)->response= value;
}

void PropertyCrowDialogButtonEntrySecondary(PropertyFuncData * data) {
	gboolean value= ModelGetBool(data->node);
	CROW_DIALOG_BUTTON_ENTRY(data->object)->secondary= value;
}

// GtkDialogProxy --------------------------------------------------------------

void GtkDialogProxy(Proxy * proxy) {
	GtkWindowProxy(proxy);
	SetCreateInstance(proxy, NULL);
	GtkContainerSetChildrenPropertyFunc(proxy, PropertyGtkDialogChildren);
	AddProperty(proxy, "has-separator", PropertyBool);
	AddProperty(proxy, "buttons", PropertyGtkDialogButtons);
	AddProperty(proxy, "default-response", PropertyGtkDialogDefaultResponse);
	AddProperty(proxy, "alternative-button-order", PropertyGtkDialogAlternativeButtonOrder);
}

void PropertyGtkDialogChildren(PropertyFuncData * data) {
	PtrArray * children= ModelGetObjectVector(data->loader, data->node);
	ContainerDialogSet(GTK_DIALOG(data->object), children);
	PtrArrayFree(children);
}

void PropertyGtkDialogButtons(PropertyFuncData * data) {
	GtkDialog * dialog= GTK_DIALOG(data->object);
	PtrArray * array= ModelGetObjectVector(data->loader, data->node);
	int i;
	for(i= 0; i < array->size; ++i)
		if(array->ptrs[i]) {
			CrowDialogButtonEntry * entry= CROW_DIALOG_BUTTON_ENTRY(array->ptrs[i]);
			if(entry->widget) {
				GtkButtonBox * area= GTK_BUTTON_BOX(gtk_dialog_get_action_area(dialog));
				if(entry->response != GTK_RESPONSE_NONE)
					gtk_dialog_add_action_widget(dialog, entry->widget, entry->response);
				else
					gtk_box_pack_end(GTK_BOX(area), entry->widget, FALSE, TRUE, 0);
				gtk_button_box_set_child_secondary(area, entry->widget, entry->secondary);
			}
		}
	PtrArrayFree(array);
}

void PropertyGtkDialogDefaultResponse(PropertyFuncData * data) {
	int value= ModelGetEnum(data->node);
	gtk_dialog_set_default_response(GTK_DIALOG(data->object), value);
}

void PropertyGtkDialogAlternativeButtonOrder(PropertyFuncData * data) {
	GtkDialog * dialog= GTK_DIALOG(data->object);
	IntArray * array= ModelGetEnumVector(data->node);
	gtk_dialog_set_alternative_button_order_from_array(dialog, array->size, array->data);
	IntArrayFree(array);
}

// CrowInfoBarButtonEntry ------------------------------------------------------

GType crow_info_bar_button_entry_get_type(void) {
	static GType object_type= 0;
	if(object_type==0) {
		static const GTypeInfo object_info= {
			sizeof(GObjectClass),
			NULL, NULL, NULL, NULL, NULL,
			sizeof(CrowInfoBarButtonEntry),
			0, (GInstanceInitFunc)crow_info_bar_button_entry_init,
		};
		object_type= g_type_register_static(G_TYPE_OBJECT, "CrowInfoBarButtonEntry", &object_info, 0);
	}
	return object_type;
}

void crow_info_bar_button_entry_init(CrowInfoBarButtonEntry * entry) {
	entry->widget= NULL;
	entry->response= GTK_RESPONSE_NONE;
}

// CrowInfoBarButtonEntryProxy -------------------------------------------------

void CrowInfoBarButtonEntryProxy(Proxy * proxy) {
	GObjectProxy(proxy);
	AddProperty(proxy, "widget", PropertyCrowInfoBarButtonEntryWidget);
	AddProperty(proxy, "response", PropertyCrowInfoBarButtonEntryResponse);
}

void PropertyCrowInfoBarButtonEntryWidget(PropertyFuncData * data) {
	GObject * value= ModelGetObject(data->loader, data->node, NULL);
	CROW_INFO_BAR_BUTTON_ENTRY(data->object)->widget= GTK_WIDGET(value);
}

void PropertyCrowInfoBarButtonEntryResponse(PropertyFuncData * data) {
	int value= ModelGetEnum(data->node);
	CROW_INFO_BAR_BUTTON_ENTRY(data->object)->response= value;
}

// GtkInfoBarProxy -------------------------------------------------------------

void GtkInfoBarProxy(Proxy * proxy) {
	GtkBinProxy(proxy);
	GtkContainerSetChildrenPropertyFunc(proxy, PropertyGtkInfoBarChildren);
	AddProperty(proxy, "message-type", PropertyEnum);
	AddProperty(proxy, "buttons", PropertyGtkInfoBarButtons);
	AddProperty(proxy, "default-response", PropertyGtkInfoBarDefaultResponse);
}

void PropertyGtkInfoBarChildren(PropertyFuncData * data) {
	PtrArray * children= ModelGetObjectVector(data->loader, data->node);
	ContainerInfoBarSet(GTK_INFO_BAR(data->object), children);
	PtrArrayFree(children);
}

void PropertyGtkInfoBarButtons(PropertyFuncData * data) {
	GtkInfoBar * widget= GTK_INFO_BAR(data->object);
	PtrArray * array= ModelGetObjectVector(data->loader, data->node);
	int i;
	for(i= 0; i < array->size; ++i)
		if(array->ptrs[i]) {
			CrowInfoBarButtonEntry * entry= CROW_INFO_BAR_BUTTON_ENTRY(array->ptrs[i]);
			if(entry->widget) {
				GtkContainer * area= GTK_CONTAINER(gtk_info_bar_get_action_area(widget));
				if(entry->response != GTK_RESPONSE_NONE)
					gtk_info_bar_add_action_widget(widget, entry->widget, entry->response);
				else
					gtk_container_add(area, entry->widget);
			}
		}
	PtrArrayFree(array);
}

void PropertyGtkInfoBarDefaultResponse(PropertyFuncData * data) {
	int value= ModelGetEnum(data->node);
	gtk_info_bar_set_default_response(GTK_INFO_BAR(data->object), value);
}

// GtkColorSelectionDialogProxy ------------------------------------------------

void GtkColorSelectionDialogProxy(Proxy * proxy) {
	GtkDialogProxy(proxy);
	AddInitInstance(proxy, GtkColorSelectionDialogInit);
	AddProperty(proxy, "colorsel", PropertyGtkColorSelectionDialogColorsel);
}

void GtkColorSelectionDialogInit(GObject * object, Node * node) {
	GtkWidget * colorsel=
		gtk_color_selection_dialog_get_color_selection(GTK_COLOR_SELECTION_DIALOG(object));
	GdkColor color= { 0, };
	gtk_color_selection_set_current_color(GTK_COLOR_SELECTION(colorsel), &color);
}

void PropertyGtkColorSelectionDialogColorsel(PropertyFuncData * data) {
	GtkWidget * widget=
		gtk_color_selection_dialog_get_color_selection(GTK_COLOR_SELECTION_DIALOG(data->object));
	CHECK(widget);
	ModelGetObject(data->loader, data->node, G_OBJECT(widget));
}

// GtkFileFilterProxy ----------------------------------------------------------

void GtkFileFilterProxy(Proxy * proxy) {
	GObjectProxy(proxy);
	AddProperty(proxy, "name", PropertyGtkFileFilterName);
	AddProperty(proxy, "add-pixbuf-formats", PropertyGtkFileFilterAddPixbufFormats);
	AddProperty(proxy, "patterns", PropertyGtkFileFilterPatterns);
	AddProperty(proxy, "mime-types", PropertyGtkFileFilterMimeTypes);
}

void PropertyGtkFileFilterName(PropertyFuncData * data) {
	const char * value= ModelGetString(data->node);
	gtk_file_filter_set_name(GTK_FILE_FILTER(data->object), value);
}

void PropertyGtkFileFilterAddPixbufFormats(PropertyFuncData * data) {
	gboolean value= ModelGetBool(data->node);
	if(value)
		gtk_file_filter_add_pixbuf_formats(GTK_FILE_FILTER(data->object));
}

void PropertyGtkFileFilterPatterns(PropertyFuncData * data) {
	GtkFileFilter * filter= GTK_FILE_FILTER(data->object);
	PtrArray * array= ModelGetStringVector(data->node);
	int i;
	for(i= 0; i < array->size; ++i)
		gtk_file_filter_add_pattern(filter, array->ptrs[i]);
	PtrArrayFree(array);
}

void PropertyGtkFileFilterMimeTypes(PropertyFuncData * data) {
	GtkFileFilter * filter= GTK_FILE_FILTER(data->object);
	PtrArray * array= ModelGetStringVector(data->node);
	int i;
	for(i= 0; i < array->size; ++i)
		gtk_file_filter_add_mime_type(filter, array->ptrs[i]);
	PtrArrayFree(array);
}

// GtkFileChooserProxyBase -----------------------------------------------------

void GtkFileChooserProxyBase(Proxy * proxy) {
	GtkWidgetProxy(proxy);
	AddProperty(proxy, "action", PropertyEnum);
	AddProperty(proxy, "extra-widget", PropertyObject);
	AddProperty(proxy, "local-only", PropertyBool);
	AddProperty(proxy, "preview-widget", PropertyObject);
	AddProperty(proxy, "preview-widget-active", PropertyBool);
	AddProperty(proxy, "select-multiple", PropertyBool);
	AddProperty(proxy, "show-hidden", PropertyBool);
	AddProperty(proxy, "use-preview-label", PropertyBool);
	AddProperty(proxy, "filter", PropertyGtkFileChooserBaseFilter);
	AddProperty(proxy, "filters", PropertyGtkFileChooserBaseFilters);
	AddProperty(proxy, "do-overwrite-confirmation", PropertyBool);
	AddProperty(proxy, "create-folders", PropertyBool);
}

void PropertyGtkFileChooserBaseFilter(PropertyFuncData * data) {
	GObject * filter= ModelGetObject(data->loader, data->node, NULL);
	gtk_file_chooser_set_filter(GTK_FILE_CHOOSER(data->object), GTK_FILE_FILTER(filter));
}

void PropertyGtkFileChooserBaseFilters(PropertyFuncData * data) {
	GtkFileChooser * chooser= GTK_FILE_CHOOSER(data->object);
	PtrArray * array= ModelGetObjectVector(data->loader, data->node);
	int i;
	for(i= 0; i < array->size; ++i)
		if(array->ptrs[i]) {
			GtkFileFilter * filter= GTK_FILE_FILTER(array->ptrs[i]);
			gtk_file_chooser_add_filter(chooser, filter);
		}
	PtrArrayFree(array);
}

// GtkFileChooserDialogProxy ---------------------------------------------------

void GtkFileChooserDialogProxy(Proxy * proxy) {
	GtkDialogProxy(proxy);
	GtkFileChooserProxyBase(proxy);
	SetCreateInstance(proxy, GtkFileChooserDialogCreate);
}

GObject * GtkFileChooserDialogCreate(GuiLoader * loader, Node * node) {
	return G_OBJECT(gtk_file_chooser_dialog_new("", NULL, GTK_FILE_CHOOSER_ACTION_OPEN, NULL, NULL));
}

// GtkFontSelectionDialogProxy -------------------------------------------------

void GtkFontSelectionDialogProxy(Proxy * proxy) {
	GtkDialogProxy(proxy);
	AddProperty(proxy, "font-selection", PropertyGtkFontSelectionDialogFontSelection);
}

void PropertyGtkFontSelectionDialogFontSelection(PropertyFuncData * data) {
	GtkWidget * widget= GTK_FONT_SELECTION_DIALOG(data->object)->fontsel;
	CHECK(widget);
	ModelGetObject(data->loader, data->node, G_OBJECT(widget));
}

// GtkStatusbarProxy -----------------------------------------------------------

void GtkStatusbarProxy(Proxy * proxy) {
	GtkContainerProxyBase(proxy);
	AddProperty(proxy, "has-resize-grip", PropertyBool);
}

// GtkActionGroupProxy ---------------------------------------------------------

void GtkActionGroupProxy(Proxy * proxy) {
	GObjectProxy(proxy);
	SetCreateInstance(proxy, GtkActionGroupCreate);
	AddProperty(proxy, "actions", PropertyGtkActionGroupActions);
	AddProperty(proxy, "sensitive", PropertyBool);
	AddProperty(proxy, "visible", PropertyBool);
}

GObject * GtkActionGroupCreate(GuiLoader * loader, Node * node) {
	Node * nname= FindNode(node, "name");
	const char * name= nname ? ModelGetString(nname) : "";
	char buffer[128];
	if(strlen(name)==0) {
		static int id = 0;
		g_snprintf(buffer, sizeof(buffer), "GtkActionGroup_%d", ++id);
		name= buffer;
	}
	return G_OBJECT(gtk_action_group_new(name));
}

void PropertyGtkActionGroupActions(PropertyFuncData * data) {
	GtkActionGroup * group= GTK_ACTION_GROUP(data->object);
	PtrArray * array= ModelGetObjectVector(data->loader, data->node);
	int i;
	for(i= 0; i < array->size; ++i)
		if(array->ptrs[i]) {
			GtkAction * action= GTK_ACTION(array->ptrs[i]);
			const char * accel= g_object_get_data(G_OBJECT(action), "CrowAcceleratorHint");
			if(!accel)
				gtk_action_group_add_action_with_accel(group, action, NULL); else
				gtk_action_group_add_action_with_accel(group, action, accel);
		}
	PtrArrayFree(array);
}

// GtkActionProxy --------------------------------------------------------------

void GtkActionProxy(Proxy * proxy) {
	GObjectProxy(proxy);
	SetCreateInstance(proxy, GtkActionCreate);
	AddProperty(proxy, "hide-if-empty", PropertyBool);
	AddProperty(proxy, "is-important", PropertyBool);
	AddProperty(proxy, "label", PropertyString);
	AddProperty(proxy, "sensitive", PropertyBool);
	AddProperty(proxy, "stock-id", PropertyString);
	AddProperty(proxy, "tooltip", PropertyString);
	AddProperty(proxy, "visible", PropertyBool);
	AddProperty(proxy, "visible-horizontal", PropertyBool);
	AddProperty(proxy, "visible-overflown", PropertyBool);
	AddProperty(proxy, "visible-vertical", PropertyBool);
	AddProperty(proxy, "accelerator", PropertyGtkActionAccelerator);
	AddProperty(proxy, "icon-name", PropertyString);
	AddProperty(proxy, "short-label", PropertyString);
	AddProperty(proxy, "widgets", PropertyGtkActionWidgets) -> lazy = TRUE;
	AddProperty(proxy, "always-show-image", PropertyBool);
}

GObject * GtkActionCreate(GuiLoader * loader, Node * node) {
	Node * nname= FindNode(node, "name");
	const char * name= nname ? ModelGetString(nname) : "";
	return G_OBJECT(gtk_action_new(name, NULL, NULL, ""));
}

void PropertyGtkActionAccelerator(PropertyFuncData * data) {
	const char * value= ModelGetString(data->node);
	g_object_set_data(data->object, "CrowAcceleratorHint", (gpointer)value);
}

void PropertyGtkActionWidgets(PropertyFuncData * data) {
	GtkAction * action= GTK_ACTION(data->object);
	PtrArray * array= ModelGetObjectVector(data->loader, data->node);
	int i;
	for(i= 0; i < array->size; ++i)
		if(array->ptrs[i]) {
			GtkActivatable * widget= GTK_ACTIVATABLE(array->ptrs[i]);
			gtk_activatable_set_related_action(widget, action);
		}
	PtrArrayFree(array);
}

// GtkToggleActionProxy --------------------------------------------------------

void GtkToggleActionProxy(Proxy * proxy) {
	GtkActionProxy(proxy);
	SetCreateInstance(proxy, GtkToggleActionCreate);
	AddProperty(proxy, "draw-as-radio", PropertyBool);
	AddProperty(proxy, "active", PropertyBool);
}

GObject * GtkToggleActionCreate(GuiLoader * loader, Node * node) {
	Node * nname= FindNode(node, "name");
	const char * name= nname ? ModelGetString(nname) : "";
	return G_OBJECT(gtk_toggle_action_new(name, NULL, NULL, ""));
}

// GtkRadioActionProxy ---------------------------------------------------------

void GtkRadioActionProxy(Proxy * proxy) {
	GtkToggleActionProxy(proxy);
	SetCreateInstance(proxy, GtkRadioActionCreate);
	AddProperty(proxy, "value", PropertyInt);
	AddProperty(proxy, "group", PropertyGtkRadioActionGroup);
	SetPropertyLazy(proxy, "active", TRUE);
}

GObject * GtkRadioActionCreate(GuiLoader * loader, Node * node) {
	Node * nname= FindNode(node, "name");
	const char * name= nname ? ModelGetString(nname) : "";
	return G_OBJECT(gtk_radio_action_new(name, NULL, NULL, "", 0));
}

void PropertyGtkRadioActionGroup(PropertyFuncData * data) {
	GObject * object= ModelGetObject(data->loader, data->node, NULL);
	CrowRadioGroup * group= CROW_RADIO_GROUP(object);
	GtkRadioAction * action= GTK_RADIO_ACTION(data->object);
	crow_radio_group_add_action(group, ShortStrGet(data->node->text), action);
}

// GtkUIManagerProxy -----------------------------------------------------------

void GtkUIManagerProxy(Proxy * proxy) {
	GObjectProxy(proxy);
	AddProperty(proxy, "add-tearoffs", PropertyBool);
	AddProperty(proxy, "action-groups", PropertyGtkUIManagerActionGroups);
	AddProperty(proxy, "ui-definitions", PropertyGtkUIManagerUiDefinitions);
}

void PropertyGtkUIManagerActionGroups(PropertyFuncData * data) {
	GtkUIManager * manager= GTK_UI_MANAGER(data->object);
	PtrArray * array= ModelGetObjectVector(data->loader, data->node);
	int i;
	for(i= 0; i < array->size; ++i)
		if(array->ptrs[i]) {
			GtkActionGroup * group= GTK_ACTION_GROUP(array->ptrs[i]);
			gtk_ui_manager_insert_action_group(manager, group, 0);
		}
	PtrArrayFree(array);
}

void PropertyGtkUIManagerUiDefinitions(PropertyFuncData * data) {
	GtkUIManager * manager= GTK_UI_MANAGER(data->object);
	PtrArray * array= ModelGetObjectVector(data->loader, data->node);
	int i;
	for(i= 0; i < array->size; ++i)
		if(array->ptrs[i]) {
			CrowUIDefinition * definition= CROW_UI_DEFINITION(array->ptrs[i]);
			guint id= gtk_ui_manager_add_ui_from_string(manager, definition->ui, -1, NULL);
			g_object_set_data(G_OBJECT(definition), "CrowMergeIdHint", GUINT_TO_POINTER(id));
		}
	PtrArrayFree(array);
}

// CrowUIDefinition ------------------------------------------------------------

GType crow_ui_definition_get_type(void) {
	static GType object_type= 0;
	if(object_type==0) {
		static const GTypeInfo object_info= {
			sizeof(GObjectClass),
			NULL, NULL, NULL, NULL, NULL,
			sizeof(CrowUIDefinition),
			0, (GInstanceInitFunc)crow_ui_definition_init,
		};
		object_type= g_type_register_static(G_TYPE_OBJECT, "CrowUIDefinition", &object_info, 0);
	}
	return object_type;
}

void crow_ui_definition_init(CrowUIDefinition * definition) {
	definition->ui= NULL;
}

// CrowUIDefinitionProxy -------------------------------------------------------

void CrowUIDefinitionProxy(Proxy * proxy) {
	GObjectProxy(proxy);
	AddProperty(proxy, "ui", PropertyCrowUIDefinitionUi);
}

void PropertyCrowUIDefinitionUi(PropertyFuncData * data) {
	const char * value= ModelGetString(data->node);
	CROW_UI_DEFINITION(data->object)->ui= value;
	//AddSharedStr(data->loader, data->node->text);
}

// CrowUIElementProxy ----------------------------------------------------------

void CrowUIElementProxy(Proxy * proxy) {
	GtkContainerProxyBase(proxy);
	SetCreateInstance(proxy, CrowUIElementCreate);
}

GObject * CrowUIElementCreate(GuiLoader * loader, Node * node) {
	Node * nelement= FindNode(node, "element");
	const char * element= nelement ? ModelGetString(nelement) : NULL;
	Node * nmanager= FindNode(node, "manager");
	GObject * manager= nmanager ? ModelGetObject(loader, nmanager, NULL) : NULL;
	GtkWidget * widget= NULL;
	if(element && manager) {
		char path[256];
		g_snprintf(path, sizeof(path), "/%s", element);
		widget= gtk_ui_manager_get_widget(GTK_UI_MANAGER(manager), path);
	}
	if(widget) {
		if(g_type_is_a(G_OBJECT_TYPE(widget), g_type_from_name(ShortStrGet(node->type)))) {
			if(!g_object_get_data(G_OBJECT(widget), "CrowUsedElement")) {
				g_object_set_data(G_OBJECT(widget), "CrowUsedElement", "true");
				g_object_ref(widget);
				return G_OBJECT(widget);
			} else
				g_warning(_("UIManager '%s': multiple usage of '%s' element"), ShortStrGet(nmanager->name), element);
		} else
			g_warning(_("UIManager '%s': type mismatch for '%s' %s"),
				ShortStrGet(nmanager->name), ShortStrGet(node->name), ShortStrGet(node->type));
	}
	if(StrEqual(ShortStrGet(node->type), "GtkMenuBar"))
		widget= gtk_menu_bar_new();
	else {
		CHECK(StrEqual(ShortStrGet(node->type), "GtkToolbar"));
		widget= gtk_toolbar_new();
	}
	return G_OBJECT(widget);
}

// GtkMenuBarProxy -------------------------------------------------------------

void GtkMenuBarProxy(Proxy * proxy) {
	CrowUIElementProxy(proxy);
	GtkWidgetAddEventProperties(proxy);
	AddProperty(proxy, "take-focus", PropertyBool);
	AddProperty(proxy, "child-pack-direction", PropertyEnum);
	AddProperty(proxy, "pack-direction", PropertyEnum);
}

// GtkToolbarProxy -------------------------------------------------------------

void GtkToolbarProxy(Proxy * proxy) {
	CrowUIElementProxy(proxy);
	GtkWidgetAddOrientationProperty(proxy);
	AddProperty(proxy, "show-arrow", PropertyBool);
	AddProperty(proxy, "toolbar-style-set", PropertyGtkToolbarToolbarStyleSet);
	AddProperty(proxy, "icon-size-set", PropertyGtkToolbarIconSizeSet);
}

void PropertyGtkToolbarToolbarStyleSet(PropertyFuncData * data) {
	gboolean value= ModelGetBool(data->node);
	if(value) {
		GtkToolbarStyle style= GTK_TOOLBAR_ICONS;
		Node * nstyle= FindNode(data->node->owner, "toolbar-style");
		if(nstyle)
			style= ModelGetEnum(nstyle);
		gtk_toolbar_set_style(GTK_TOOLBAR(data->object), style);
	}
}

void PropertyGtkToolbarIconSizeSet(PropertyFuncData * data) {
	gboolean value= ModelGetBool(data->node);
	if(value) {
		GtkIconSize size= GTK_ICON_SIZE_LARGE_TOOLBAR;
		Node * nsize= FindNode(data->node->owner, "icon-size");
		if(nsize)
			size= ModelGetEnum(nsize);
		gtk_toolbar_set_icon_size(GTK_TOOLBAR(data->object), size);
	}
}

// GtkToolPaletteProxy ---------------------------------------------------------

void GtkToolPaletteProxy(Proxy * proxy) {
	GtkContainerProxyBase(proxy);
	GtkWidgetAddOrientationProperty(proxy);
	AddProperty(proxy, "toolbar-style-set", PropertyGtkToolPaletteToolbarStyleSet);
	AddProperty(proxy, "icon-size-set", PropertyGtkToolPaletteIconSizeSet);
}

void PropertyGtkToolPaletteToolbarStyleSet(PropertyFuncData * data) {
	gboolean value= ModelGetBool(data->node);
	if(value) {
		GtkToolbarStyle style= GTK_TOOLBAR_ICONS;
		Node * nstyle= FindNode(data->node->owner, "toolbar-style");
		if(nstyle)
			style= ModelGetEnum(nstyle);
		gtk_tool_palette_set_style(GTK_TOOL_PALETTE(data->object), style);
	}
}

void PropertyGtkToolPaletteIconSizeSet(PropertyFuncData * data) {
	gboolean value= ModelGetBool(data->node);
	if(value) {
		GtkIconSize size= GTK_ICON_SIZE_SMALL_TOOLBAR;
		Node * nsize= FindNode(data->node->owner, "icon-size");
		if(nsize)
			size= ModelGetEnum(nsize);
		gtk_tool_palette_set_icon_size(GTK_TOOL_PALETTE(data->object), size);
	}
}

// CrowRadioGroup --------------------------------------------------------------

GType crow_radio_group_get_type(void) {
	static GType object_type= 0;
	if(object_type==0) {
		static const GTypeInfo object_info= {
			sizeof(GObjectClass),
			NULL, NULL, NULL, NULL, NULL,
			sizeof(CrowRadioGroup),
			0, (GInstanceInitFunc)crow_radio_group_init,
		};
		object_type= g_type_register_static(G_TYPE_OBJECT, "CrowRadioGroup", &object_info, 0);
	}
	return object_type;
}

void crow_radio_group_init(CrowRadioGroup * group) {
	group->glist= NULL;
	group->gtype= G_TYPE_INVALID;
}

gboolean crow_radio_group_verify(CrowRadioGroup * group, char * name, GType type) {
	if(group->gtype==type || group->gtype==G_TYPE_INVALID) {
		group->gtype= type;
		return TRUE;
	} else {
		g_warning(_("type mismatch for '%s' CrowRadioGroup, expecting %s"), name, g_type_name(group->gtype));
		return FALSE;
	}
}

void crow_radio_group_add_action(CrowRadioGroup * group, char * name, GtkRadioAction * action) {
	if(crow_radio_group_verify(group, name, GTK_TYPE_RADIO_ACTION)) {
		gtk_radio_action_set_group(action, group->glist);
		group->glist= gtk_radio_action_get_group(action);
	}
}

void crow_radio_group_add_button(CrowRadioGroup * group, char * name, GtkRadioButton * button) {
	if(crow_radio_group_verify(group, name, GTK_TYPE_RADIO_BUTTON)) {
		gtk_radio_button_set_group(button, group->glist);
		group->glist= gtk_radio_button_get_group(button);
	}
}

// CrowRadioGroupProxy ---------------------------------------------------------

void CrowRadioGroupProxy(Proxy * proxy) {
	GObjectProxy(proxy);
}

// GtkMiscProxy ----------------------------------------------------------------

void GtkMiscProxy(Proxy * proxy) {
	GtkWidgetProxy(proxy);
	AddProperty(proxy, "xalign", PropertyFloat);
	AddProperty(proxy, "xpad", PropertyInt);
	AddProperty(proxy, "yalign", PropertyFloat);
	AddProperty(proxy, "ypad", PropertyInt);
}

// GtkLabelProxy ---------------------------------------------------------------

void GtkLabelProxy(Proxy * proxy) {
	GtkMiscProxy(proxy);
	AddProperty(proxy, "angle", PropertyDouble);
	AddProperty(proxy, "ellipsize", PropertyEnum);
	AddProperty(proxy, "justify", PropertyEnum);
	AddProperty(proxy, "label", PropertyString);
	AddProperty(proxy, "max-width-chars", PropertyInt);
	AddProperty(proxy, "mnemonic-widget", PropertyObject);
	AddProperty(proxy, "selectable", PropertyBool);
	AddProperty(proxy, "single-line-mode", PropertyBool);
	AddProperty(proxy, "use-markup", PropertyBool);
	AddProperty(proxy, "use-underline", PropertyBool);
	AddProperty(proxy, "wrap-mode", PropertyEnum);
	AddProperty(proxy, "wrap", PropertyBool);
	AddProperty(proxy, "track-visited-links", PropertyBool);
}

// GtkButtonProxyBase ----------------------------------------------------------

void GtkButtonProxyBase(Proxy * proxy) {
	GtkWidgetProxy(proxy);
	GtkWidgetAddReceivesDefaultProperty(proxy);
	GtkWidgetAddCanFocusProperty(proxy);
	GtkWidgetAddCanDefaultProperty(proxy);
	AddProperty(proxy, "focus-on-click", PropertyBool);
	AddProperty(proxy, "relief", PropertyEnum);
	AddProperty(proxy, "xalign", PropertyFloat);
	AddProperty(proxy, "yalign", PropertyFloat);
}

// GtkButtonProxy --------------------------------------------------------------

void GtkButtonProxy(Proxy * proxy) {
	GtkBinProxy(proxy);
	GtkButtonProxyBase(proxy);
	AddProperty(proxy, "use-action-appearance", PropertyBool);
	AddProperty(proxy, "stock-id", PropertyGtkButtonStockId);
	AddProperty(proxy, "label", PropertyString);
	AddProperty(proxy, "image", PropertyObject);
	AddProperty(proxy, "use-underline", PropertyBool);
	AddProperty(proxy, "image-position", PropertyEnum);
}

void PropertyGtkButtonStockId(PropertyFuncData * data) {
	const char * value= ModelGetString(data->node);
	gtk_button_set_label(GTK_BUTTON(data->object), value);
	gtk_button_set_use_stock(GTK_BUTTON(data->object), TRUE);
}

// GtkToggleButtonProxy --------------------------------------------------------

void GtkToggleButtonProxy(Proxy * proxy) {
	GtkButtonProxy(proxy);
	AddProperty(proxy, "active", PropertyBool);
	AddProperty(proxy, "inconsistent", PropertyBool);
}

// GtkCheckButtonProxy ---------------------------------------------------------

void GtkCheckButtonProxy(Proxy * proxy) {
	GtkToggleButtonProxy(proxy);
	AddProperty(proxy, "draw-indicator", PropertyBool);
}

// GtkRadioButtonProxy ---------------------------------------------------------

void GtkRadioButtonProxy(Proxy * proxy) {
	GtkCheckButtonProxy(proxy);
	AddProperty(proxy, "group", PropertyGtkRadioButtonGroup);
	SetPropertyLazy(proxy, "active", TRUE);
}

void PropertyGtkRadioButtonGroup(PropertyFuncData * data) {
	GObject * object= ModelGetObject(data->loader, data->node, NULL);
	CrowRadioGroup * group= CROW_RADIO_GROUP(object);
	GtkRadioButton * button= GTK_RADIO_BUTTON(data->object);
	crow_radio_group_add_button(group, ShortStrGet(data->node->text), button);
}

// GtkScaleButtonProxy ---------------------------------------------------------

void GtkScaleButtonProxy(Proxy * proxy) {
	GtkContainerProxyBase(proxy);
	GtkButtonProxyBase(proxy);
	SetCreateInstance(proxy, GtkScaleButtonCreate);
	GtkWidgetAddOrientationProperty(proxy);
	AddProperty(proxy, "adjustment", PropertyObject);
	AddProperty(proxy, "size", PropertyEnum);
	AddProperty(proxy, "icons", PropertyGtkScaleButtonIcons);
}

GObject * GtkScaleButtonCreate(GuiLoader * loader, Node * node) {
	return G_OBJECT(gtk_scale_button_new(GTK_ICON_SIZE_SMALL_TOOLBAR, 0, 0, 0, NULL));
}

void PropertyGtkScaleButtonIcons(PropertyFuncData * data) {
	GtkScaleButton * button= GTK_SCALE_BUTTON(data->object);
	PtrArray * array= ModelGetStringVector(data->node);
	char ** icons= g_slice_alloc(sizeof(gpointer)*(array->size+1));
	memmove(icons, array->ptrs, sizeof(gpointer)*array->size);
	icons[array->size]= NULL;
	gtk_scale_button_set_icons(button, (const char **)icons);
	g_slice_free1(sizeof(gpointer)*(array->size+1), icons);
	PtrArrayFree(array);
}

// GtkEntryCompletionProxy -----------------------------------------------------

void GtkEntryCompletionProxy(Proxy * proxy) {
	GObjectProxy(proxy);
	AddProperty(proxy, "inline-completion", PropertyBool);
	AddProperty(proxy, "minimum-key-length", PropertyInt);
	AddProperty(proxy, "popup-completion", PropertyBool);
	AddProperty(proxy, "strings", PropertyGtkEntryCompletionStrings);
	AddProperty(proxy, "popup-set-width", PropertyBool);
	AddProperty(proxy, "popup-single-match", PropertyBool);
	AddProperty(proxy, "inline-selection", PropertyBool);
}

void PropertyGtkEntryCompletionStrings(PropertyFuncData * data) {
	GtkEntryCompletion * completion= GTK_ENTRY_COMPLETION(data->object);
	GtkListStore * model= gtk_list_store_new(1, G_TYPE_STRING);
	GtkTreeIter iter;
	PtrArray * array= ModelGetStringVector(data->node);
	int i;
	for(i= 0; i < array->size; ++i) {
		gtk_list_store_append(model, &iter);
		gtk_list_store_set(model, &iter, 0, array->ptrs[i], -1);
	}
	gtk_entry_completion_set_model(completion, GTK_TREE_MODEL(model));
	gtk_entry_completion_set_text_column(completion, 0);
	PtrArrayFree(array);
}

// GtkEntryProxy ---------------------------------------------------------------

void GtkEntryProxy(Proxy * proxy) {
	GtkWidgetProxy(proxy);
	GtkWidgetAddCanFocusProperty(proxy);
	GtkWidgetAddEventProperties(proxy);
	AddProperty(proxy, "activates-default", PropertyBool);
	AddProperty(proxy, "editable", PropertyBool);
	AddProperty(proxy, "has-frame", PropertyBool);
	AddProperty(proxy, "invisible-char", PropertyChar);
	AddProperty(proxy, "max-length", PropertyInt);
	AddProperty(proxy, "text", PropertyString);
	AddProperty(proxy, "visibility", PropertyBool);
	AddProperty(proxy, "width-chars", PropertyInt);
	AddProperty(proxy, "xalign", PropertyFloat);
	AddProperty(proxy, "completion", PropertyGtkEntryCompletion);
	AddProperty(proxy, "inner-border-set", PropertyGtkEntryInnerBorderSet);
	AddProperty(proxy, "truncate-multiline", PropertyBool);
	AddProperty(proxy, "shadow-type", PropertyEnum);
	AddProperty(proxy, "caps-lock-warning", PropertyBool);
	AddProperty(proxy, "overwrite-mode", PropertyBool);
	AddProperty(proxy, "progress-fraction", PropertyDouble);
	AddProperty(proxy, "progress-pulse-step", PropertyDouble);
	AddProperty(proxy, "primary-icon-name", PropertyString);
	AddProperty(proxy, "primary-icon-tooltip", PropertyGtkEntryPrimaryIconTooltip);
	AddProperty(proxy, "primary-icon-sensitive", PropertyBool);
	AddProperty(proxy, "primary-icon-activatable", PropertyBool);
	AddProperty(proxy, "secondary-icon-name", PropertyGtkEntrySecondaryIconName);
	AddProperty(proxy, "secondary-icon-tooltip", PropertyGtkEntrySecondaryIconTooltip);
	AddProperty(proxy, "secondary-icon-sensitive", PropertyBool);
	AddProperty(proxy, "secondary-icon-activatable", PropertyBool);
}

void PropertyGtkEntryCompletion(PropertyFuncData * data) {
	GObject * object= ModelGetObject(data->loader, data->node, NULL);
	gtk_entry_set_completion(GTK_ENTRY(data->object), GTK_ENTRY_COMPLETION(object));
}

void PropertyGtkEntryInnerBorderSet(PropertyFuncData * data) {
	gboolean set= ModelGetBool(data->node);
	if(set) {
		GtkBorder border= { 0, 0, 0, 0 };
		Node * nborder= FindNode(data->node->owner, "inner-border");
		if(nborder)
			border= ModelGetGtkBorder(nborder);
		gtk_entry_set_inner_border(GTK_ENTRY(data->object), &border);
	}
}

void PropertyGtkEntryPrimaryIconTooltip(PropertyFuncData * data) {
	GtkEntry * widget= GTK_ENTRY(data->object);
	if(gtk_entry_get_icon_name(widget, GTK_ENTRY_ICON_PRIMARY)) {
		const char * str= ModelGetString(data->node);
		CrowTooltipMode mode= CROW_TOOLTIP_TEXT;
		Node * nmode= FindNode(data->node->owner, "tooltip-mode");
		if(nmode)
			mode= ModelGetTooltipMode(nmode);
		switch(mode) {
			case CROW_TOOLTIP_TEXT:
				gtk_entry_set_icon_tooltip_text(widget, GTK_ENTRY_ICON_PRIMARY, str);
				break;
			case CROW_TOOLTIP_MARKUP:
				gtk_entry_set_icon_tooltip_markup(widget, GTK_ENTRY_ICON_PRIMARY, str);
				break;
			case CROW_TOOLTIP_TEXT_OFF:
				break;
			case CROW_TOOLTIP_MARKUP_OFF:
				break;
			default:
				CHECK(FALSE);
		}
	}
}

void PropertyGtkEntrySecondaryIconName(PropertyFuncData * data) {
	GtkEntry * widget= GTK_ENTRY(data->object);
	const char * str= ModelGetString(data->node);
	gtk_entry_set_icon_from_icon_name(widget, GTK_ENTRY_ICON_SECONDARY, str);
	g_object_set(data->object, "caps-lock-warning", FALSE, NULL);
}

void PropertyGtkEntrySecondaryIconTooltip(PropertyFuncData * data) {
	GtkEntry * widget= GTK_ENTRY(data->object);
	if(gtk_entry_get_icon_name(widget, GTK_ENTRY_ICON_SECONDARY)) {
		const char * str= ModelGetString(data->node);
		CrowTooltipMode mode= CROW_TOOLTIP_TEXT;
		Node * nmode= FindNode(data->node->owner, "tooltip-mode");
		if(nmode)
			mode= ModelGetTooltipMode(nmode);
		switch(mode) {
			case CROW_TOOLTIP_TEXT:
				gtk_entry_set_icon_tooltip_text(widget, GTK_ENTRY_ICON_SECONDARY, str);
				break;
			case CROW_TOOLTIP_MARKUP:
				gtk_entry_set_icon_tooltip_markup(widget, GTK_ENTRY_ICON_SECONDARY, str);
				break;
			case CROW_TOOLTIP_TEXT_OFF:
				break;
			case CROW_TOOLTIP_MARKUP_OFF:
				break;
			default:
				CHECK(FALSE);
		}
	}
}

// GtkComboBoxProxy ------------------------------------------------------------

void GtkComboBoxProxy(Proxy * proxy) {
	GtkContainerProxyBase(proxy);
	SetCreateInstance(proxy, GtkComboBoxCreate);
	AddProperty(proxy, "add-tearoffs", PropertyBool);
	AddProperty(proxy, "focus-on-click", PropertyBool);
	AddProperty(proxy, "strings", PropertyGtkComboBoxStrings);
	AddProperty(proxy, "active", PropertyInt);
	AddProperty(proxy, "tearoff-title", PropertyString);
	AddProperty(proxy, "button-sensitivity", PropertyEnum);
}

GObject * GtkComboBoxCreate(GuiLoader * loader, Node * node) {
	Node * ntext= FindNode(node, "text-mode");
	gboolean text= ntext ? ModelGetBool(ntext) : FALSE;
	if(!text)
		return G_OBJECT(gtk_combo_box_new()); else
		return G_OBJECT(gtk_combo_box_new_text());
}

void PropertyGtkComboBoxStrings(PropertyFuncData * data) {
	GtkComboBox * combo= GTK_COMBO_BOX(data->object);
	PtrArray * array= ModelGetStringVector(data->node);
	int i;
	for(i= 0; i < array->size; ++i)
		gtk_combo_box_append_text(combo, array->ptrs[i]);
	PtrArrayFree(array);
}

// GtkComboBoxEntryProxy -------------------------------------------------------

void GtkComboBoxEntryProxy(Proxy * proxy) {
	GtkComboBoxProxy(proxy);
	SetCreateInstance(proxy, GtkComboBoxEntryCreate);
	AddProperty(proxy, "has-frame", PropertyBool);
	AddProperty(proxy, "text", PropertyGtkComboBoxEntryText);
	AddProperty(proxy, "entry", PropertyGtkComboBoxEntryEntry);
}

GObject * GtkComboBoxEntryCreate(GuiLoader * loader, Node * node) {
	Node * ntext= FindNode(node, "text-mode");
	gboolean text= ntext ? ModelGetBool(ntext) : FALSE;
	if(!text)
		return G_OBJECT(gtk_combo_box_entry_new()); else
		return G_OBJECT(gtk_combo_box_entry_new_text());
}

void PropertyGtkComboBoxEntryText(PropertyFuncData * data) {
	GtkEntry * entry= GTK_ENTRY(gtk_bin_get_child(GTK_BIN(data->object)));
	const char * value= ModelGetString(data->node);
	gtk_entry_set_text(entry, value);
}

void PropertyGtkComboBoxEntryEntry(PropertyFuncData * data) {
	GtkEntry * entry= GTK_ENTRY(gtk_bin_get_child(GTK_BIN(data->object)));
	ModelGetObject(data->loader, data->node, G_OBJECT(entry));
}

// GtkSpinButtonProxy ----------------------------------------------------------

void GtkSpinButtonProxy(Proxy * proxy) {
	GtkEntryProxy(proxy);
	AddProperty(proxy, "adjustment", PropertyObject);
	AddProperty(proxy, "climb-rate", PropertyDouble);
	AddProperty(proxy, "digits", PropertyUnsigned);
	AddProperty(proxy, "numeric", PropertyBool);
	AddProperty(proxy, "snap-to-ticks", PropertyBool);
	AddProperty(proxy, "update-policy", PropertyEnum);
	AddProperty(proxy, "value", PropertyDouble);
	AddProperty(proxy, "wrap", PropertyBool);
}

// GtkRangeProxy ---------------------------------------------------------------

void GtkRangeProxy(Proxy * proxy) {
	GtkWidgetProxy(proxy);
	AddInitInstance(proxy, GtkRangeProxyInit);
	GtkWidgetAddOrientationProperty(proxy);
	AddProperty(proxy, "inverted", PropertyBool);
	AddProperty(proxy, "update-policy", PropertyEnum);
	AddProperty(proxy, "show-fill-level", PropertyBool);
	AddProperty(proxy, "restrict-to-fill-level", PropertyBool);
	AddProperty(proxy, "fill-level", PropertyDouble);
	AddProperty(proxy, "adjustment", PropertyObject);
	AddProperty(proxy, "lower-stepper-sensitivity", PropertyEnum);
	AddProperty(proxy, "upper-stepper-sensitivity", PropertyEnum);
}

void GtkRangeProxyInit(GObject * object, Node * node) {
	gtk_range_set_fill_level(GTK_RANGE(object), 0);
	gtk_range_set_restrict_to_fill_level(GTK_RANGE(object), FALSE);
}

// CrowScaleMarkEntry ----------------------------------------------------------

GType crow_scale_mark_entry_get_type(void) {
	static GType object_type= 0;
	if(object_type==0) {
		static const GTypeInfo object_info= {
			sizeof(GObjectClass),
			NULL, NULL, NULL, NULL, NULL,
			sizeof(CrowScaleMarkEntry),
			0, (GInstanceInitFunc)crow_scale_mark_entry_init,
		};
		object_type= g_type_register_static(G_TYPE_OBJECT, "CrowScaleMarkEntry", &object_info, 0);
	}
	return object_type;
}

void crow_scale_mark_entry_init(CrowScaleMarkEntry * entry) {
	entry->value= 0;
	entry->position= GTK_POS_BOTTOM;
	entry->caption= NULL;
}

// CrowScaleMarkEntryProxy -----------------------------------------------------

void CrowScaleMarkEntryProxy(Proxy * proxy) {
	GObjectProxy(proxy);
	AddProperty(proxy, "value", PropertyCrowScaleMarkEntryValue);
	AddProperty(proxy, "position", PropertyCrowScaleMarkEntryPosition);
	AddProperty(proxy, "caption", PropertyCrowScaleMarkEntryCaption);
}

void PropertyCrowScaleMarkEntryValue(PropertyFuncData * data) {
	gdouble value= ModelGetDouble(data->node);
	CROW_SCALE_MARK_ENTRY(data->object)->value= value;
}

void PropertyCrowScaleMarkEntryPosition(PropertyFuncData * data) {
	int value= ModelGetEnum(data->node);
	CROW_SCALE_MARK_ENTRY(data->object)->position= value;
}

void PropertyCrowScaleMarkEntryCaption(PropertyFuncData * data) {
	const char * value= ModelGetString(data->node);
	CROW_SCALE_MARK_ENTRY(data->object)->caption= value;
}

// GtkScaleProxy ---------------------------------------------------------------

void GtkScaleProxy(Proxy * proxy) {
	GtkRangeProxy(proxy);
	AddProperty(proxy, "digits", PropertyInt);
	AddProperty(proxy, "draw-value", PropertyBool);
	AddProperty(proxy, "value-pos", PropertyEnum);
	GtkWidgetAddCanFocusProperty(proxy);
	AddProperty(proxy, "marks", PropertyGtkScaleMarks);
}

void PropertyGtkScaleMarks(PropertyFuncData * data) {
	GtkScale * widget= GTK_SCALE(data->object);
	PtrArray * array= ModelGetObjectVector(data->loader, data->node);
	int i;
	for(i= 0; i < array->size; ++i)
		if(array->ptrs[i]) {
			CrowScaleMarkEntry * entry= CROW_SCALE_MARK_ENTRY(array->ptrs[i]);
			CHECK(entry);
			gtk_scale_add_mark(widget, entry->value, entry->position, entry->caption);
		}
	PtrArrayFree(array);
}

// GtkProgressBarProxy ---------------------------------------------------------

void GtkProgressBarProxy(Proxy * proxy) {
	GtkWidgetProxy(proxy);
	GtkWidgetAddEventProperties(proxy);
	AddProperty(proxy, "text", PropertyString);
	AddProperty(proxy, "fraction", PropertyDouble);
	AddProperty(proxy, "pulse-step", PropertyDouble);
	AddProperty(proxy, "orientation", PropertyEnum);
	AddProperty(proxy, "ellipsize", PropertyEnum);
}

// GtkImageProxy ---------------------------------------------------------------

void GtkImageProxy(Proxy * proxy) {
	GtkMiscProxy(proxy);
	AddProperty(proxy, "icon-name", PropertyString);
	AddProperty(proxy, "icon-size", PropertyEnum);
	AddProperty(proxy, "pixel-size", PropertyInt);
}

// GtkSeparatorProxy -----------------------------------------------------------

void GtkSeparatorProxy(Proxy * proxy) {
	GtkWidgetProxy(proxy);
	GtkWidgetAddOrientationProperty(proxy);
}

// GtkSizeGroupProxy -----------------------------------------------------------

void GtkSizeGroupProxy(Proxy * proxy) {
	GObjectProxy(proxy);
	AddProperty(proxy, "mode", PropertyEnum);
	AddProperty(proxy, "ignore-hidden", PropertyBool);
	AddProperty(proxy, "widgets", PropertyGtkSizeGroupWidgets);
}

void PropertyGtkSizeGroupWidgets(PropertyFuncData * data) {
	GtkSizeGroup * group= GTK_SIZE_GROUP(data->object);
	PtrArray * array= ModelGetObjectVector(data->loader, data->node);
	int i;
	for(i= 0; i < array->size; ++i)
		if(array->ptrs[i]) {
			GtkWidget * widget= GTK_WIDGET(array->ptrs[i]);
			gtk_size_group_add_widget(group, widget);
		}
	PtrArrayFree(array);
}

// GtkTextViewProxy ------------------------------------------------------------

void GtkTextViewProxy(Proxy * proxy) {
	GtkContainerProxyBase(proxy);
	GtkWidgetAddCanFocusProperty(proxy);
	GtkWidgetAddEventProperties(proxy);
	AddProperty(proxy, "accepts-tab", PropertyBool);
	AddProperty(proxy, "cursor-visible", PropertyBool);
	AddProperty(proxy, "editable", PropertyBool);
	AddProperty(proxy, "indent", PropertyInt);
	AddProperty(proxy, "justification", PropertyEnum);
	AddProperty(proxy, "left-margin", PropertyInt);
	AddProperty(proxy, "overwrite", PropertyBool);
	AddProperty(proxy, "pixels-above-lines", PropertyInt);
	AddProperty(proxy, "pixels-below-lines", PropertyInt);
	AddProperty(proxy, "pixels-inside-wrap", PropertyInt);
	AddProperty(proxy, "right-margin", PropertyInt);
	AddProperty(proxy, "wrap-mode", PropertyEnum);
	AddProperty(proxy, "text", PropertyGtkTextViewText);
}

void PropertyGtkTextViewText(PropertyFuncData * data) {
	GtkTextBuffer * buffer= gtk_text_view_get_buffer(GTK_TEXT_VIEW(data->object));
	const char * value= ModelGetString(data->node);
	gtk_text_buffer_set_text(buffer, value, -1);
}

// GtkIconViewProxy ------------------------------------------------------------

void GtkIconViewProxy(Proxy * proxy) {
	GtkContainerProxyBase(proxy);
	GtkWidgetAddCanFocusProperty(proxy);
	GtkWidgetAddEventProperties(proxy);
	GtkWidgetAddOrientationProperty(proxy);
	AddProperty(proxy, "column-spacing", PropertyInt);
	AddProperty(proxy, "columns", PropertyInt);
	AddProperty(proxy, "item-width", PropertyInt);
	AddProperty(proxy, "margin", PropertyInt);
	AddProperty(proxy, "row-spacing", PropertyInt);
	AddProperty(proxy, "selection-mode", PropertyEnum);
	AddProperty(proxy, "spacing", PropertyInt);
	AddProperty(proxy, "reorderable", PropertyBool);
	AddProperty(proxy, "item-padding", PropertyInt);
}

// GtkCellViewProxy ------------------------------------------------------------

void GtkCellViewProxy(Proxy * proxy) {
	GtkWidgetProxy(proxy);
	AddProperty(proxy, "background-set", PropertyBool);
	AddProperty(proxy, "background-gdk", PropertyColor);
}

// GtkTreeViewProxy ------------------------------------------------------------

void GtkTreeViewProxy(Proxy * proxy) {
	GtkContainerProxyBase(proxy);
	GtkWidgetAddCanFocusProperty(proxy);
	GtkWidgetAddEventProperties(proxy);
	AddProperty(proxy, "enable-search", PropertyBool);
	AddProperty(proxy, "fixed-height-mode", PropertyBool);
	AddProperty(proxy, "headers-visible", PropertyBool);
	AddProperty(proxy, "hover-expand", PropertyBool);
	AddProperty(proxy, "hover-selection", PropertyBool);
	AddProperty(proxy, "reorderable", PropertyBool);
	AddProperty(proxy, "rules-hint", PropertyBool);
	AddProperty(proxy, "selection-mode", PropertyGtkTreeViewSelectionMode);
	AddProperty(proxy, "rubber-banding", PropertyBool);
	AddProperty(proxy, "show-expanders", PropertyBool);
	AddProperty(proxy, "level-indentation", PropertyInt);
	AddProperty(proxy, "enable-grid-lines", PropertyEnum);
	AddProperty(proxy, "enable-tree-lines", PropertyBool);
	AddProperty(proxy, "search-entry", PropertyGtkTreeViewSearchEntry);
}

void PropertyGtkTreeViewSelectionMode(PropertyFuncData * data) {
	GtkTreeSelection * selection= gtk_tree_view_get_selection(GTK_TREE_VIEW(data->object));
	int value= ModelGetEnum(data->node);
	gtk_tree_selection_set_mode(selection, value);
}

void PropertyGtkTreeViewSearchEntry(PropertyFuncData * data) {
	if(!GUI_LOADER_GET_PRIVATE(data->loader)->preview) {
		GObject * entry= ModelGetObject(data->loader, data->node, NULL);
		gtk_tree_view_set_search_entry(GTK_TREE_VIEW(data->object), entry ? GTK_ENTRY(entry) : NULL);
	}
}

// GtkColorButtonProxy ---------------------------------------------------------

void GtkColorButtonProxy(Proxy * proxy) {
	GtkContainerProxyBase(proxy);
	GtkButtonProxyBase(proxy);
	AddProperty(proxy, "alpha", PropertyUnsigned);
	AddProperty(proxy, "title", PropertyString);
	AddProperty(proxy, "use-alpha", PropertyBool);
	AddProperty(proxy, "color", PropertyColor);
}

// GtkColorSelectionProxy ------------------------------------------------------

void GtkColorSelectionProxy(Proxy * proxy) {
	GtkContainerProxyBase(proxy);
	AddProperty(proxy, "has-opacity-control", PropertyBool);
	AddProperty(proxy, "has-palette", PropertyBool);
	AddProperty(proxy, "current-alpha", PropertyUnsigned);
	AddProperty(proxy, "current-color", PropertyColor);
}

// GtkFileChooserButtonProxy ---------------------------------------------------

void GtkFileChooserButtonProxy(Proxy * proxy) {
	GtkContainerProxyBase(proxy);
	GtkFileChooserProxyBase(proxy);
	SetCreateInstance(proxy, GtkFileChooserButtonCreate);
	AddProperty(proxy, "title", PropertyString);
	AddProperty(proxy, "width-chars", PropertyInt);
	AddProperty(proxy, "focus-on-click", PropertyBool);
}

GObject * GtkFileChooserButtonCreate(GuiLoader * loader, Node * node) {
	return G_OBJECT(gtk_file_chooser_button_new(NULL, GTK_FILE_CHOOSER_ACTION_OPEN));
}

// GtkFileChooserWidgetProxy ---------------------------------------------------

void GtkFileChooserWidgetProxy(Proxy * proxy) {
	GtkContainerProxyBase(proxy);
	GtkFileChooserProxyBase(proxy);
	SetCreateInstance(proxy, GtkFileChooserWidgetCreate);
}

GObject * GtkFileChooserWidgetCreate(GuiLoader * loader, Node * node) {
	return G_OBJECT(gtk_file_chooser_widget_new(GTK_FILE_CHOOSER_ACTION_OPEN));
}

// GtkFontButtonProxy ----------------------------------------------------------

void GtkFontButtonProxy(Proxy * proxy) {
	GtkContainerProxyBase(proxy);
	GtkButtonProxyBase(proxy);
	AddProperty(proxy, "font-name", PropertyString);
	AddProperty(proxy, "show-size", PropertyBool);
	AddProperty(proxy, "show-style", PropertyBool);
	AddProperty(proxy, "title", PropertyString);
	AddProperty(proxy, "use-font", PropertyBool);
	AddProperty(proxy, "use-size", PropertyBool);
}

// GtkFontSelectionProxy -------------------------------------------------------

void GtkFontSelectionProxy(Proxy * proxy) {
	GtkContainerProxyBase(proxy);
}

// GtkFixedProxy ---------------------------------------------------------------

void GtkFixedProxy(Proxy * proxy) {
	GtkContainerProxy(proxy);
	GtkContainerSetChildrenPropertyFunc(proxy, PropertyGtkFixedChildren);
	AddProperty(proxy, "has-window", PropertyBool);
}

void PropertyGtkFixedChildren(PropertyFuncData * data) {
	PtrArray * children= ModelGetObjectVector(data->loader, data->node);
	ContainerFixedSet(GTK_FIXED(data->object), children);
	PtrArrayFree(children);
}

// GtkLayoutProxy --------------------------------------------------------------

void GtkLayoutProxy(Proxy * proxy) {
	GtkContainerProxy(proxy);
	GtkContainerSetChildrenPropertyFunc(proxy, PropertyGtkLayoutChildren);
	AddProperty(proxy, "size", PropertyGtkLayoutSize);
}

void PropertyGtkLayoutChildren(PropertyFuncData * data) {
	PtrArray * children= ModelGetObjectVector(data->loader, data->node);
	ContainerLayoutSet(GTK_LAYOUT(data->object), children);
	PtrArrayFree(children);
}

void PropertyGtkLayoutSize(PropertyFuncData * data) {
	CrowPoint p= ModelGetPoint(data->node);
	gtk_layout_set_size(GTK_LAYOUT(data->object), p.x, p.y);
}

// GtkScrollbarProxy -----------------------------------------------------------

void GtkScrollbarProxy(Proxy * proxy) {
	GtkRangeProxy(proxy);
	GtkWidgetAddCanFocusProperty(proxy);
}

// GtkEventBoxProxy ------------------------------------------------------------

void GtkEventBoxProxy(Proxy * proxy) {
	GtkBinProxy(proxy);
	GtkWidgetAddAppPaintableProperty(proxy);
	GtkWidgetAddEventProperties(proxy);
	AddProperty(proxy, "above-child", PropertyBool);
	AddProperty(proxy, "visible-window", PropertyBool);
}

// GtkDrawingAreaProxy ---------------------------------------------------------

void GtkDrawingAreaProxy(Proxy * proxy) {
	GtkWidgetProxy(proxy);
	GtkWidgetAddEventProperties(proxy);
}

// GtkCalendarProxy ------------------------------------------------------------

void GtkCalendarProxy(Proxy * proxy) {
	GtkWidgetProxy(proxy);
	GtkWidgetAddCanFocusProperty(proxy);
	GtkWidgetAddEventProperties(proxy);
	AddProperty(proxy, "no-month-change", PropertyBool);
	AddProperty(proxy, "show-day-names", PropertyBool);
	AddProperty(proxy, "show-heading", PropertyBool);
	AddProperty(proxy, "show-week-numbers", PropertyBool);
	AddProperty(proxy, "detail-height-rows", PropertyInt);
	AddProperty(proxy, "detail-width-chars", PropertyInt);
	AddProperty(proxy, "show-details", PropertyBool);
}

// GtkArrowProxy ---------------------------------------------------------------

void GtkArrowProxy(Proxy * proxy) {
	GtkMiscProxy(proxy);
	AddProperty(proxy, "arrow-type", PropertyEnum);
	AddProperty(proxy, "shadow-type", PropertyEnum);
}

// CrowCustom ------------------------------------------------------------------

GType crow_custom_get_type(void) {
	static GType object_type= 0;
	if(object_type==0) {
		static const GTypeInfo object_info= {
			sizeof(CrowCustomClass),
			NULL,
			NULL,
			(GClassInitFunc)crow_custom_class_init,
			NULL,
			NULL,
			sizeof(CrowCustom),
			0,
			NULL,
		};
	  object_type= g_type_register_static(GTK_TYPE_DRAWING_AREA, "CrowCustom", &object_info, 0);
	}
	return object_type;
}

void crow_custom_class_init(CrowCustomClass * meta) {
	GtkWidgetClass * widget= (GtkWidgetClass *)meta;
	widget->size_request= crow_custom_size_request;
	widget->expose_event= crow_custom_expose;
}

GtkWidget * crow_custom_new(void) {
  return g_object_new(CROW_TYPE_CUSTOM, NULL);
}

void crow_custom_size_request(GtkWidget * widget, GtkRequisition * requisition) {
	requisition->width= 40;
	requisition->height= 40;
}

int crow_custom_expose(GtkWidget * widget, GdkEventExpose * event) {
	DrawGrid(gtk_widget_get_window(widget), gtk_widget_get_style(widget), TRUE);
  return FALSE;
}

// CrowCustomProxy -------------------------------------------------------------

void CrowCustomProxy(Proxy * proxy) {
	GtkWidgetProxy(proxy);
	SetCreateInstance(proxy, CrowCustomCreate);
}

GObject * CrowCustomCreate(GuiLoader * loader, Node * node) {
	Node * ntype= FindNode(node, "type");
	Node * nmeta= FindNode(node, "meta");
	Node * ntext= FindNode(node, "text");
	const char * type= ntype ? ModelGetString(ntype) : "";
	const char * meta= nmeta ? ModelGetString(nmeta) : "";
	const char * text= ntext ? ModelGetString(ntext) : "";
	GuiLoaderPrivate * priv= GUI_LOADER_GET_PRIVATE(loader);
	GtkWidget * widget;
	CustomConstructor * constructor= g_hash_table_lookup(priv->constructors, type);
	if(!constructor && !StrEqual(type, ""))
		constructor= g_hash_table_lookup(priv->constructors, "");
	if(constructor) {
		widget= constructor->func(type, meta, text, constructor->data);
		CHECK(GTK_IS_WIDGET(widget) && !GTK_IS_WINDOW(widget));
	} else
		widget= crow_custom_new();
	return G_OBJECT(widget);
}

// GtkStatusIconProxy ----------------------------------------------------------

void GtkStatusIconProxy(Proxy * proxy) {
	GObjectProxy(proxy);
	SetCreateInstance(proxy, GtkStatusIconCreate);
	AddProperty(proxy, "blinking", PropertyBool);
	AddProperty(proxy, "visible", PropertyBool);
	AddProperty(proxy, "icon-name", PropertyString);
	AddProperty(proxy, "tooltip", PropertyGtkStatusIconTooltip);
	AddProperty(proxy, "title", PropertyString);
	AddProperty(proxy, "name", PropertyGtkStatusIconName);
}

GObject * GtkStatusIconCreate(GuiLoader * loader, Node * node) {
	GtkStatusIcon * obj= gtk_status_icon_new();
	gtk_status_icon_set_visible(obj, FALSE);
	return G_OBJECT(obj);
}

void PropertyGtkStatusIconTooltip(PropertyFuncData * data) {
	const char * str= ModelGetString(data->node);
	GtkStatusIcon * widget= GTK_STATUS_ICON(data->object);
	CrowTooltipMode mode= CROW_TOOLTIP_TEXT;
	Node * nmode= FindNode(data->node->owner, "tooltip-mode");
	if(nmode)
		mode= ModelGetTooltipMode(nmode);
	switch(mode) {
		case CROW_TOOLTIP_TEXT:
			gtk_status_icon_set_tooltip_text(widget, str);
			break;
		case CROW_TOOLTIP_MARKUP:
			gtk_status_icon_set_tooltip_markup(widget, str);
			break;
		case CROW_TOOLTIP_TEXT_OFF:
			gtk_status_icon_set_tooltip_text(widget, str);
			gtk_status_icon_set_has_tooltip(widget, FALSE);
			break;
		case CROW_TOOLTIP_MARKUP_OFF:
			gtk_status_icon_set_tooltip_markup(widget, str);
			gtk_status_icon_set_has_tooltip(widget, FALSE);
			break;
		default:
			CHECK(FALSE);
	}
}

void PropertyGtkStatusIconName(PropertyFuncData * data) {
	const char * str= ModelGetString(data->node);
	gtk_status_icon_set_name(GTK_STATUS_ICON(data->object), str);
}

// GtkLinkButtonProxy ----------------------------------------------------------

void GtkLinkButtonProxy(Proxy * proxy) {
	GtkContainerProxyBase(proxy);
	GtkButtonProxyBase(proxy);
	SetCreateInstance(proxy, GtkLinkButtonCreate);
	AddProperty(proxy, "label", PropertyString);
	AddProperty(proxy, "uri", PropertyString);
	AddProperty(proxy, "visited", PropertyBool);
}

GObject * GtkLinkButtonCreate(GuiLoader * loader, Node * node) {
	return G_OBJECT(gtk_link_button_new_with_label("http://www.gtk.org", ""));
}

// GtkRecentFilterProxy --------------------------------------------------------

void GtkRecentFilterProxy(Proxy * proxy) {
	GObjectProxy(proxy);
	AddProperty(proxy, "name", PropertyGtkRecentFilterName);
	AddProperty(proxy, "add-pixbuf-formats", PropertyGtkRecentFilterAddPixbufFormats);
	AddProperty(proxy, "patterns", PropertyGtkRecentFilterPatterns);
	AddProperty(proxy, "mime-types", PropertyGtkRecentFilterMimeTypes);
	AddProperty(proxy, "applications", PropertyGtkRecentFilterApplications);
	AddProperty(proxy, "groups", PropertyGtkRecentFilterGroups);
	AddProperty(proxy, "age", PropertyGtkRecentFilterAge);
}

void PropertyGtkRecentFilterName(PropertyFuncData * data) {
	const char * value= ModelGetString(data->node);
	gtk_recent_filter_set_name(GTK_RECENT_FILTER(data->object), value);
}

void PropertyGtkRecentFilterAddPixbufFormats(PropertyFuncData * data) {
	gboolean value= ModelGetBool(data->node);
	if(value)
		gtk_recent_filter_add_pixbuf_formats(GTK_RECENT_FILTER(data->object));
}

void PropertyGtkRecentFilterPatterns(PropertyFuncData * data) {
	GtkRecentFilter * filter= GTK_RECENT_FILTER(data->object);
	PtrArray * array= ModelGetStringVector(data->node);
	int i;
	for(i= 0; i < array->size; ++i)
		gtk_recent_filter_add_pattern(filter, array->ptrs[i]);
	PtrArrayFree(array);
}

void PropertyGtkRecentFilterMimeTypes(PropertyFuncData * data) {
	GtkRecentFilter * filter= GTK_RECENT_FILTER(data->object);
	PtrArray * array= ModelGetStringVector(data->node);
	int i;
	for(i= 0; i < array->size; ++i)
		gtk_recent_filter_add_mime_type(filter, array->ptrs[i]);
	PtrArrayFree(array);
}

void PropertyGtkRecentFilterApplications(PropertyFuncData * data) {
	GtkRecentFilter * filter= GTK_RECENT_FILTER(data->object);
	PtrArray * array= ModelGetStringVector(data->node);
	int i;
	for(i= 0; i < array->size; ++i)
		gtk_recent_filter_add_application(filter, array->ptrs[i]);
	PtrArrayFree(array);
}

void PropertyGtkRecentFilterGroups(PropertyFuncData * data) {
	GtkRecentFilter * filter= GTK_RECENT_FILTER(data->object);
	PtrArray * array= ModelGetStringVector(data->node);
	int i;
	for(i= 0; i < array->size; ++i)
		gtk_recent_filter_add_group(filter, array->ptrs[i]);
	PtrArrayFree(array);
}

void PropertyGtkRecentFilterAge(PropertyFuncData * data) {
	int value= ModelGetInt(data->node);
	gtk_recent_filter_add_age(GTK_RECENT_FILTER(data->object), value);
}

// GtkRecentChooserProxyBase ---------------------------------------------------

void GtkRecentChooserProxyBase(Proxy * proxy) {
	GObjectProxy(proxy);
	AddInitInstance(proxy, GtkRecentChooserBaseInit);
	AddProperty(proxy, "limit", PropertyInt);
	AddProperty(proxy, "local-only", PropertyBool);
	AddProperty(proxy, "select-multiple", PropertyBool);
	AddProperty(proxy, "show-icons", PropertyBool);
	AddProperty(proxy, "show-not-found", PropertyBool);
	AddProperty(proxy, "show-private", PropertyBool);
	AddProperty(proxy, "show-tips", PropertyBool);
	AddProperty(proxy, "sort-type", PropertyEnum);
	AddProperty(proxy, "filter", PropertyGtkRecentChooserBaseFilter);
	AddProperty(proxy, "filters", PropertyGtkRecentChooserBaseFilters);
}

void GtkRecentChooserBaseInit(GObject * object, Node * node) {
	GtkRecentChooser * chooser= GTK_RECENT_CHOOSER(object);
	gtk_recent_chooser_set_limit(chooser, -1);
	gtk_recent_chooser_set_show_not_found(chooser, FALSE);
	gtk_recent_chooser_set_show_tips(chooser, FALSE);
}

void PropertyGtkRecentChooserBaseFilter(PropertyFuncData * data) {
	GObject * filter= ModelGetObject(data->loader, data->node, NULL);
	gtk_recent_chooser_set_filter(GTK_RECENT_CHOOSER(data->object), GTK_RECENT_FILTER(filter));
}

void PropertyGtkRecentChooserBaseFilters(PropertyFuncData * data) {
	GtkRecentChooser * chooser= GTK_RECENT_CHOOSER(data->object);
	PtrArray * array= ModelGetObjectVector(data->loader, data->node);
	int i;
	for(i= 0; i < array->size; ++i)
		if(array->ptrs[i]) {
			GtkRecentFilter * filter= GTK_RECENT_FILTER(array->ptrs[i]);
			gtk_recent_chooser_add_filter(chooser, filter);
		}
	PtrArrayFree(array);
}

// GtkRecentChooserWidgetProxy -------------------------------------------------

void GtkRecentChooserWidgetProxy(Proxy * proxy) {
	GtkContainerProxyBase(proxy);
	GtkRecentChooserProxyBase(proxy);
}

// GtkRecentChooserDialogProxy -------------------------------------------------

void GtkRecentChooserDialogProxy(Proxy * proxy) {
	GtkDialogProxy(proxy);
	GtkRecentChooserProxyBase(proxy);
}

// GtkRecentActionProxy --------------------------------------------------------

void GtkRecentActionProxy(Proxy * proxy) {
	GtkActionProxy(proxy);
	GtkRecentChooserProxyBase(proxy);
	SetCreateInstance(proxy, GtkRecentActionCreate);
	AddProperty(proxy, "show-numbers", PropertyBool);
}

GObject * GtkRecentActionCreate(GuiLoader * loader, Node * node) {
	Node * nname= FindNode(node, "name");
	const char * name= nname ? ModelGetString(nname) : "";
	return G_OBJECT(gtk_recent_action_new(name, NULL, NULL, ""));
}

// GtkSpinnerProxy ---------------------------------------------------------

void GtkSpinnerProxy(Proxy * proxy) {
	GtkDrawingAreaProxy(proxy);
	AddProperty(proxy, "active", PropertyBool);
}

// -----------------------------------------------------------------------------
